/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically by tools/build/nativecall.pl
 * from definitions in src/call_list.txt
 *
 * Any changes made here will be lost!
 *
 */

/* nci.c
 *  Copyright (C) 2001-2007, The Perl Foundation.
 *  SVN Info
 *     $Id$
 *  Overview:
 *     Native Call Interface routines. The code needed to build a
 *     parrot to C call frame is in here
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *  References:
 */
#include "parrot/parrot.h"
#include "parrot/hash.h"
#include "parrot/oplib/ops.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

/*
 * if the architecture can build some or all of these signatures
 * enable the define below
 * - the JITed function will be called first
 * - if it returns NULL, the hardcoded version will do the job
 */

#if defined(HAS_JIT) && defined(I386)
#  include "parrot/exec.h"
#  include "jit.h"
/*#  define CAN_BUILD_CALL_FRAMES*/
#endif

/*
 * helper funcs - get argument n
 */
static INTVAL
get_nci_I(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_int(st->val);
}

static FLOATVAL
get_nci_N(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_num(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static STRING*
get_nci_S(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /* TODO or act like below? */
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_str(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
get_nci_P(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /*
     * exessive args are passed as NULL
     * used by e.g. MMD infix like __add
     */
    if (n < st->src.n)
        Parrot_fetch_arg_nci(interp, st);
    else
        UVal_pmc(st->val) = PMCNULL;

    return UVal_pmc(st->val);
}

#define GET_NCI_I(n) get_nci_I(interp, &st, n)
#define GET_NCI_S(n) get_nci_S(interp, &st, n)
#define GET_NCI_N(n) get_nci_N(interp, &st, n)
#define GET_NCI_P(n) get_nci_P(interp, &st, n)

/*
 * set return value
 */
static void
set_nci_I(PARROT_INTERP, ARGOUT(call_state *st), INTVAL val)
{
    Parrot_init_ret_nci(interp, st, "I");
    if (st->dest.i < st->dest.n) {
        UVal_int(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_N(PARROT_INTERP, ARGOUT(call_state *st), FLOATVAL val)
{
    Parrot_init_ret_nci(interp, st, "N");
    if (st->dest.i < st->dest.n) {
        UVal_num(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_S(PARROT_INTERP, ARGOUT(call_state *st), STRING *val)
{
    Parrot_init_ret_nci(interp, st, "S");
    if (st->dest.i < st->dest.n) {
        UVal_str(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_P(PARROT_INTERP, ARGOUT(call_state *st), PMC* val)
{
    Parrot_init_ret_nci(interp, st, "P");
    if (st->dest.i < st->dest.n) {
        UVal_pmc(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

/* All our static functions that call in various ways. Yes, terribly
   hackish, but that is just fine */

static void
pcf_d_JOd(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(PARROT_INTERP, PMC *, double);
    func_t pointer;
    call_state st;
    double return_data;
    
    PMC *t_1;
    double t_2;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_1 = GET_NCI_P(0);
    t_2 = (double)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(interp,PMC_IS_NULL(t_1) ? NULL : t_1,t_2);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_I_JOS(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_4;
    STRING *t_5;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_4 = GET_NCI_P(0);
    t_5 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_4) ? NULL : t_4,t_5);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOl(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, long);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_7;
    long t_8;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_7 = GET_NCI_P(0);
    t_8 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_7) ? NULL : t_7,t_8);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_Jt(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    char *t_10;
    Parrot_init_arg_nci(interp, &st, "S");
    t_10 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,t_10);
    
    set_nci_P(interp, &st, return_data);
    string_cstring_free(t_10);
}
static void
pcf_S_JOS(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_12;
    STRING *t_13;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_12 = GET_NCI_P(0);
    t_13 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_12) ? NULL : t_12,t_13);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_I_JI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    INTVAL t_15;
    Parrot_init_arg_nci(interp, &st, "I");
    t_15 = GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,t_15);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JOSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_17;
    STRING *t_18;
    PMC *t_19;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_17 = GET_NCI_P(0);
    t_18 = GET_NCI_S(1);
    t_19 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_17) ? NULL : t_17,t_18,PMC_IS_NULL(t_19) ? NULL : t_19);
    
    
    
}
static void
pcf_v_JOS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_21;
    STRING *t_22;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_21 = GET_NCI_P(0);
    t_22 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_21) ? NULL : t_21,t_22);
    
    
    
}
static void
pcf_P_JOS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_24;
    STRING *t_25;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_24 = GET_NCI_P(0);
    t_25 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_24) ? NULL : t_24,t_25);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_27;
    INTVAL t_28;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_27 = GET_NCI_P(0);
    t_28 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_27) ? NULL : t_27,t_28);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_30;
    PMC *t_31;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_30 = GET_NCI_P(0);
    t_31 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_30) ? NULL : t_30,PMC_IS_NULL(t_31) ? NULL : t_31);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_33;
    PMC *t_34;
    STRING *t_35;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_33 = GET_NCI_P(0);
    t_34 = GET_NCI_P(1);
    t_35 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_33) ? NULL : t_33,PMC_IS_NULL(t_34) ? NULL : t_34,t_35);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_37;
    PMC *t_38;
    STRING *t_39;
    PMC *t_40;
    Parrot_init_arg_nci(interp, &st, "PPSP");
    t_37 = GET_NCI_P(0);
    t_38 = GET_NCI_P(1);
    t_39 = GET_NCI_S(2);
    t_40 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_37) ? NULL : t_37,PMC_IS_NULL(t_38) ? NULL : t_38,t_39,PMC_IS_NULL(t_40) ? NULL : t_40);
    
    
    
}
static void
pcf_v_JPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_42;
    PMC *t_43;
    PMC *t_44;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_42 = GET_NCI_P(0);
    t_43 = GET_NCI_P(1);
    t_44 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_42) ? NULL : t_42,PMC_IS_NULL(t_43) ? NULL : t_43,PMC_IS_NULL(t_44) ? NULL : t_44);
    
    
    
}
static void
pcf_v_JPIP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_46;
    INTVAL t_47;
    PMC *t_48;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_46 = GET_NCI_P(0);
    t_47 = GET_NCI_I(1);
    t_48 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_46) ? NULL : t_46,t_47,PMC_IS_NULL(t_48) ? NULL : t_48);
    
    
    
}
static void
pcf_v_JPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_50;
    STRING *t_51;
    PMC *t_52;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_50 = GET_NCI_P(0);
    t_51 = GET_NCI_S(1);
    t_52 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_50) ? NULL : t_50,t_51,PMC_IS_NULL(t_52) ? NULL : t_52);
    
    
    
}
static void
pcf_v_JPNP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_54;
    FLOATVAL t_55;
    PMC *t_56;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_54 = GET_NCI_P(0);
    t_55 = GET_NCI_N(1);
    t_56 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_54) ? NULL : t_54,t_55,PMC_IS_NULL(t_56) ? NULL : t_56);
    
    
    
}
static void
pcf_v_JPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_58;
    PMC *t_59;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_58 = GET_NCI_P(0);
    t_59 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_58) ? NULL : t_58,PMC_IS_NULL(t_59) ? NULL : t_59);
    
    
    
}
static void
pcf_v_JPI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_61;
    INTVAL t_62;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_61 = GET_NCI_P(0);
    t_62 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_61) ? NULL : t_61,t_62);
    
    
    
}
static void
pcf_v_JPS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_64;
    STRING *t_65;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_64 = GET_NCI_P(0);
    t_65 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_64) ? NULL : t_64,t_65);
    
    
    
}
static void
pcf_v_JPN(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_67;
    FLOATVAL t_68;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_67 = GET_NCI_P(0);
    t_68 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_67) ? NULL : t_67,t_68);
    
    
    
}
static void
pcf_P_JPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_70;
    PMC *t_71;
    PMC *t_72;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_70 = GET_NCI_P(0);
    t_71 = GET_NCI_P(1);
    t_72 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_70) ? NULL : t_70,PMC_IS_NULL(t_71) ? NULL : t_71,PMC_IS_NULL(t_72) ? NULL : t_72);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPIP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_74;
    INTVAL t_75;
    PMC *t_76;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_74 = GET_NCI_P(0);
    t_75 = GET_NCI_I(1);
    t_76 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_74) ? NULL : t_74,t_75,PMC_IS_NULL(t_76) ? NULL : t_76);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPSP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_78;
    STRING *t_79;
    PMC *t_80;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_78 = GET_NCI_P(0);
    t_79 = GET_NCI_S(1);
    t_80 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_78) ? NULL : t_78,t_79,PMC_IS_NULL(t_80) ? NULL : t_80);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPNP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_82;
    FLOATVAL t_83;
    PMC *t_84;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_82 = GET_NCI_P(0);
    t_83 = GET_NCI_N(1);
    t_84 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_82) ? NULL : t_82,t_83,PMC_IS_NULL(t_84) ? NULL : t_84);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JPP(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_86;
    PMC *t_87;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_86 = GET_NCI_P(0);
    t_87 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_86) ? NULL : t_86,PMC_IS_NULL(t_87) ? NULL : t_87);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_89;
    Parrot_init_arg_nci(interp, &st, "P");
    t_89 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_89) ? NULL : t_89);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_91;
    Parrot_init_arg_nci(interp, &st, "P");
    t_91 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_91) ? NULL : t_91);
    
    
    
}
static void
pcf_i_JPi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_93;
    int t_94;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_93 = GET_NCI_P(0);
    t_94 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_93) ? NULL : t_93,t_94);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_96;
    int t_97;
    int t_98;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_96 = GET_NCI_P(0);
    t_97 = (int)GET_NCI_I(1);
    t_98 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_96) ? NULL : t_96,t_97,t_98);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_100;
    int t_101;
    int t_102;
    int t_103;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_100 = GET_NCI_P(0);
    t_101 = (int)GET_NCI_I(1);
    t_102 = (int)GET_NCI_I(2);
    t_103 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_100) ? NULL : t_100,t_101,t_102,t_103);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_105;
    char *t_106;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_105 = GET_NCI_P(0);
    t_106 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_105) ? NULL : t_105,t_106);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_106);
}
static void
pcf_P_JOSSS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_108;
    STRING *t_109;
    STRING *t_110;
    STRING *t_111;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_108 = GET_NCI_P(0);
    t_109 = GET_NCI_S(1);
    t_110 = GET_NCI_S(2);
    t_111 = GET_NCI_S(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_108) ? NULL : t_108,t_109,t_110,t_111);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOSS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_113;
    STRING *t_114;
    STRING *t_115;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_113 = GET_NCI_P(0);
    t_114 = GET_NCI_S(1);
    t_115 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_113) ? NULL : t_113,t_114,t_115);
    
    
    
}
static void
pcf_S_JOI(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_117;
    INTVAL t_118;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_117 = GET_NCI_P(0);
    t_118 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_117) ? NULL : t_117,t_118);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOb(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_120;
    STRING *t_121;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_120 = GET_NCI_P(0);
    t_121 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_120) ? NULL : t_120,PObj_bufstart(t_121));
    
    
    
}
static void
pcf_i_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_123;
    PMC *t_124;
    PMC *t_125;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_123 = GET_NCI_P(0);
    t_124 = GET_NCI_P(1);
    t_125 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_123) ? NULL : t_123,PMC_IS_NULL(t_124) ? NULL : t_124,PMC_IS_NULL(t_125) ? NULL : t_125);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_127;
    PMC *t_128;
    PMC *t_129;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_127 = GET_NCI_P(0);
    t_128 = GET_NCI_P(1);
    t_129 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_127) ? NULL : t_127,PMC_IS_NULL(t_128) ? NULL : t_128,PMC_IS_NULL(t_129) ? NULL : t_129);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOIPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_131;
    INTVAL t_132;
    PMC *t_133;
    PMC *t_134;
    Parrot_init_arg_nci(interp, &st, "PIP@");
    t_131 = GET_NCI_P(0);
    t_132 = GET_NCI_I(1);
    t_133 = GET_NCI_P(2);
    t_134 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_131) ? NULL : t_131,t_132,PMC_IS_NULL(t_133) ? NULL : t_133,PMC_IS_NULL(t_134) ? NULL : t_134);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JO(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_136;
    Parrot_init_arg_nci(interp, &st, "P");
    t_136 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_136) ? NULL : t_136);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_138;
    PMC *t_139;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_138 = GET_NCI_P(0);
    t_139 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_138) ? NULL : t_138,PMC_IS_NULL(t_139) ? NULL : t_139);
    
    
    
}
static void
pcf_P_Ji(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    int t_141;
    Parrot_init_arg_nci(interp, &st, "I");
    t_141 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,t_141);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_i_ip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_142;
    PMC *t_143;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_142 = (int)GET_NCI_I(0);
    t_143 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_142,PMC_data(t_143));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_145;
    int t_146;
    PMC *t_147;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_145 = GET_NCI_P(0);
    t_146 = (int)GET_NCI_I(1);
    t_147 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_145) ? NULL : t_145,t_146,PMC_data(t_147));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JpP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_149;
    PMC *t_150;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_149 = GET_NCI_P(0);
    t_150 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_data(t_149),PMC_IS_NULL(t_150) ? NULL : t_150);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_Jpii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_152;
    int t_153;
    int t_154;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_152 = GET_NCI_P(0);
    t_153 = (int)GET_NCI_I(1);
    t_154 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_data(t_152),t_153,t_154);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_155;
    Parrot_init_arg_nci(interp, &st, "P");
    t_155 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_155));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_tp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_156;
    PMC *t_157;
    Parrot_init_arg_nci(interp, &st, "SP");
    t_156 = string_to_cstring(interp, GET_NCI_S(0));
    t_157 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_156,PMC_data(t_157));
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_156);
}
static void
pcf_p_J(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    Parrot_init_arg_nci(interp, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_160;
    Parrot_init_arg_nci(interp, &st, "P");
    t_160 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,PMC_data(t_160));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_t_J(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;
    Parrot_init_arg_nci(interp, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interp);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_Jpti(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP, void *, char *, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_163;
    char *t_164;
    int t_165;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_163 = GET_NCI_P(0);
    t_164 = string_to_cstring(interp, GET_NCI_S(1));
    t_165 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interp,PMC_data(t_163),t_164,t_165);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_164);
}
static void
pcf_t_p(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_166;
    Parrot_init_arg_nci(interp, &st, "P");
    t_166 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_166));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_167;
    char *t_168;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_167 = GET_NCI_P(0);
    t_168 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_167),t_168);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_168);
}
static void
pcf_v_p(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_169;
    Parrot_init_arg_nci(interp, &st, "P");
    t_169 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_169));
    
    
    
}
static void
pcf_v_pit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, char *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_170;
    int t_171;
    char *t_172;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_170 = GET_NCI_P(0);
    t_171 = (int)GET_NCI_I(1);
    t_172 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_170),t_171,t_172);
    
    
    string_cstring_free(t_172);
}
static void
pcf_v_ptt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *, char *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_173;
    char *t_174;
    char *t_175;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_173 = GET_NCI_P(0);
    t_174 = string_to_cstring(interp, GET_NCI_S(1));
    t_175 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_173),t_174,t_175);
    
    
    string_cstring_free(t_174);
    string_cstring_free(t_175);
}
static void
pcf_v_Jtiiipt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, char *, int, int, int, void *, char *);
    func_t pointer;
    call_state st;
    
    
    char *t_177;
    int t_178;
    int t_179;
    int t_180;
    PMC *t_181;
    char *t_182;
    Parrot_init_arg_nci(interp, &st, "SIIIPS");
    t_177 = string_to_cstring(interp, GET_NCI_S(0));
    t_178 = (int)GET_NCI_I(1);
    t_179 = (int)GET_NCI_I(2);
    t_180 = (int)GET_NCI_I(3);
    t_181 = GET_NCI_P(4);
    t_182 = string_to_cstring(interp, GET_NCI_S(5));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,t_177,t_178,t_179,t_180,PMC_data(t_181),t_182);
    
    
    string_cstring_free(t_177);
    string_cstring_free(t_182);
}
static void
pcf_v_(PARROT_INTERP, PMC *self)
{
    void (*pointer)(void);
    
    
    
    

    pointer =  (void (*)(void))D2FPTR(PMC_struct_val(self));
     (void)(*pointer)();
    
    
}
static void
pcf_v_Jiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_184;
    int t_185;
    int t_186;
    PMC *t_187;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_184 = (int)GET_NCI_I(0);
    t_185 = (int)GET_NCI_I(1);
    t_186 = (int)GET_NCI_I(2);
    t_187 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,t_184,t_185,t_186,PMC_data(t_187));
    
    
    
}
static void
pcf_v_i(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int);
    func_t pointer;
    call_state st;
    
    
    int t_188;
    Parrot_init_arg_nci(interp, &st, "I");
    t_188 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_188);
    
    
    
}
static void
pcf_v_ii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int);
    func_t pointer;
    call_state st;
    
    
    int t_189;
    int t_190;
    Parrot_init_arg_nci(interp, &st, "II");
    t_189 = (int)GET_NCI_I(0);
    t_190 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_189,t_190);
    
    
    
}
static void
pcf_v_illllllll(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long, long, long, long, long, long, long);
    func_t pointer;
    call_state st;
    
    
    int t_191;
    long t_192;
    long t_193;
    long t_194;
    long t_195;
    long t_196;
    long t_197;
    long t_198;
    long t_199;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIII");
    t_191 = (int)GET_NCI_I(0);
    t_192 = (long)GET_NCI_I(1);
    t_193 = (long)GET_NCI_I(2);
    t_194 = (long)GET_NCI_I(3);
    t_195 = (long)GET_NCI_I(4);
    t_196 = (long)GET_NCI_I(5);
    t_197 = (long)GET_NCI_I(6);
    t_198 = (long)GET_NCI_I(7);
    t_199 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_191,t_192,t_193,t_194,t_195,t_196,t_197,t_198,t_199);
    
    
    
}
static void
pcf_v_l(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(long);
    func_t pointer;
    call_state st;
    
    
    long t_200;
    Parrot_init_arg_nci(interp, &st, "I");
    t_200 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_200);
    
    
    
}
static void
pcf_v_pbip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_201;
    STRING *t_202;
    int t_203;
    PMC *t_204;
    Parrot_init_arg_nci(interp, &st, "PSIP");
    t_201 = GET_NCI_P(0);
    t_202 = GET_NCI_S(1);
    t_203 = (int)GET_NCI_I(2);
    t_204 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_201),PObj_bufstart(t_202),t_203,PMC_data(t_204));
    
    
    
}
static void
pcf_v_pi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_205;
    int t_206;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_205 = GET_NCI_P(0);
    t_206 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_205),t_206);
    
    
    
}
static void
pcf_v_piiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_207;
    int t_208;
    int t_209;
    int t_210;
    int t_211;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_207 = GET_NCI_P(0);
    t_208 = (int)GET_NCI_I(1);
    t_209 = (int)GET_NCI_I(2);
    t_210 = (int)GET_NCI_I(3);
    t_211 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_207),t_208,t_209,t_210,t_211);
    
    
    
}
static void
pcf_v_pl(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long);
    func_t pointer;
    call_state st;
    
    
    PMC *t_212;
    long t_213;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_212 = GET_NCI_P(0);
    t_213 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_212),t_213);
    
    
    
}
static void
pcf_v_pp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_214;
    PMC *t_215;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_214 = GET_NCI_P(0);
    t_215 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_214),PMC_data(t_215));
    
    
    
}
static void
pcf_i_JPP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_217;
    PMC *t_218;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_217 = GET_NCI_P(0);
    t_218 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_217) ? NULL : t_217,PMC_IS_NULL(t_218) ? NULL : t_218);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_220;
    Parrot_init_arg_nci(interp, &st, "P");
    t_220 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_220) ? NULL : t_220);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_222;
    PMC *t_223;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_222 = GET_NCI_P(0);
    t_223 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_222) ? NULL : t_222,PMC_IS_NULL(t_223) ? NULL : t_223);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JO(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_225;
    Parrot_init_arg_nci(interp, &st, "P");
    t_225 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_225) ? NULL : t_225);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_P(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_226;
    Parrot_init_arg_nci(interp, &st, "P");
    t_226 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_IS_NULL(t_226) ? NULL : t_226);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_228;
    PMC *t_229;
    PMC *t_230;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_228 = GET_NCI_P(0);
    t_229 = GET_NCI_P(1);
    t_230 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_228) ? NULL : t_228,PMC_IS_NULL(t_229) ? NULL : t_229,PMC_IS_NULL(t_230) ? NULL : t_230);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_232;
    PMC *t_233;
    PMC *t_234;
    PMC *t_235;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_232 = GET_NCI_P(0);
    t_233 = GET_NCI_P(1);
    t_234 = GET_NCI_P(2);
    t_235 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_232) ? NULL : t_232,PMC_IS_NULL(t_233) ? NULL : t_233,PMC_IS_NULL(t_234) ? NULL : t_234,PMC_IS_NULL(t_235) ? NULL : t_235);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_237;
    PMC *t_238;
    PMC *t_239;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_237 = GET_NCI_P(0);
    t_238 = GET_NCI_P(1);
    t_239 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_237) ? NULL : t_237,PMC_IS_NULL(t_238) ? NULL : t_238,PMC_IS_NULL(t_239) ? NULL : t_239);
    
    
    
}
static void
pcf_v_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_241;
    PMC *t_242;
    PMC *t_243;
    PMC *t_244;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_241 = GET_NCI_P(0);
    t_242 = GET_NCI_P(1);
    t_243 = GET_NCI_P(2);
    t_244 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_241) ? NULL : t_241,PMC_IS_NULL(t_242) ? NULL : t_242,PMC_IS_NULL(t_243) ? NULL : t_243,PMC_IS_NULL(t_244) ? NULL : t_244);
    
    
    
}
static void
pcf_P_JOPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_246;
    PMC *t_247;
    PMC *t_248;
    PMC *t_249;
    PMC *t_250;
    Parrot_init_arg_nci(interp, &st, "PPPPP");
    t_246 = GET_NCI_P(0);
    t_247 = GET_NCI_P(1);
    t_248 = GET_NCI_P(2);
    t_249 = GET_NCI_P(3);
    t_250 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_246) ? NULL : t_246,PMC_IS_NULL(t_247) ? NULL : t_247,PMC_IS_NULL(t_248) ? NULL : t_248,PMC_IS_NULL(t_249) ? NULL : t_249,PMC_IS_NULL(t_250) ? NULL : t_250);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_252;
    PMC *t_253;
    PMC *t_254;
    PMC *t_255;
    PMC *t_256;
    PMC *t_257;
    Parrot_init_arg_nci(interp, &st, "PPPPPP");
    t_252 = GET_NCI_P(0);
    t_253 = GET_NCI_P(1);
    t_254 = GET_NCI_P(2);
    t_255 = GET_NCI_P(3);
    t_256 = GET_NCI_P(4);
    t_257 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_252) ? NULL : t_252,PMC_IS_NULL(t_253) ? NULL : t_253,PMC_IS_NULL(t_254) ? NULL : t_254,PMC_IS_NULL(t_255) ? NULL : t_255,PMC_IS_NULL(t_256) ? NULL : t_256,PMC_IS_NULL(t_257) ? NULL : t_257);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOSI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_259;
    STRING *t_260;
    INTVAL t_261;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_259 = GET_NCI_P(0);
    t_260 = GET_NCI_S(1);
    t_261 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_259) ? NULL : t_259,t_260,t_261);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOSII(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL, INTVAL);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_263;
    STRING *t_264;
    INTVAL t_265;
    INTVAL t_266;
    Parrot_init_arg_nci(interp, &st, "PSII");
    t_263 = GET_NCI_P(0);
    t_264 = GET_NCI_S(1);
    t_265 = GET_NCI_I(2);
    t_266 = GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_263) ? NULL : t_263,t_264,t_265,t_266);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_p_Ji(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_268;
    Parrot_init_arg_nci(interp, &st, "I");
    t_268 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_268);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jipp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int, void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_270;
    PMC *t_271;
    PMC *t_272;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_270 = (int)GET_NCI_I(0);
    t_271 = GET_NCI_P(1);
    t_272 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_270,PMC_data(t_271),PMC_data(t_272));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jbip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *, int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_274;
    int t_275;
    PMC *t_276;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_274 = GET_NCI_S(0);
    t_275 = (int)GET_NCI_I(1);
    t_276 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,PObj_bufstart(t_274),t_275,PMC_data(t_276));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_Jp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_278;
    Parrot_init_arg_nci(interp, &st, "P");
    t_278 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_data(t_278));
    
    
    
}
static void
pcf_v_JS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, STRING *);
    func_t pointer;
    call_state st;
    
    
    STRING *t_280;
    Parrot_init_arg_nci(interp, &st, "S");
    t_280 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,t_280);
    
    
    
}
static void
pcf_t_tt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_281;
    char *t_282;
    Parrot_init_arg_nci(interp, &st, "SS");
    t_281 = string_to_cstring(interp, GET_NCI_S(0));
    t_282 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_281,t_282);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_281);
    string_cstring_free(t_282);
}
static void
pcf_I_JOt(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_284;
    char *t_285;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_284 = GET_NCI_P(0);
    t_285 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_284) ? NULL : t_284,t_285);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_285);
}
static void
pcf_v_JOSI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_287;
    STRING *t_288;
    INTVAL t_289;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_287 = GET_NCI_P(0);
    t_288 = GET_NCI_S(1);
    t_289 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_287) ? NULL : t_287,t_288,t_289);
    
    
    
}
static void
pcf_S_JOi(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_291;
    int t_292;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_291 = GET_NCI_P(0);
    t_292 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_291) ? NULL : t_291,t_292);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_294;
    int t_295;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_294 = GET_NCI_P(0);
    t_295 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_294) ? NULL : t_294,t_295);
    
    
    
}
static void
pcf_I_JO(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_297;
    Parrot_init_arg_nci(interp, &st, "P");
    t_297 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_297) ? NULL : t_297);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_N_JO(PARROT_INTERP, PMC *self)
{
    typedef FLOATVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    FLOATVAL return_data;
    
    PMC *t_299;
    Parrot_init_arg_nci(interp, &st, "P");
    t_299 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (FLOATVAL)(*pointer)(interp,PMC_IS_NULL(t_299) ? NULL : t_299);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_v_JON(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_301;
    FLOATVAL t_302;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_301 = GET_NCI_P(0);
    t_302 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_301) ? NULL : t_301,t_302);
    
    
    
}
static void
pcf_P_JOi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_304;
    int t_305;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_304 = GET_NCI_P(0);
    t_305 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_304) ? NULL : t_304,t_305);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_307;
    INTVAL t_308;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_307 = GET_NCI_P(0);
    t_308 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_307) ? NULL : t_307,t_308);
    
    
    
}
static void
pcf_P_JOI(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_310;
    INTVAL t_311;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_310 = GET_NCI_P(0);
    t_311 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_310) ? NULL : t_310,t_311);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOIS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_313;
    INTVAL t_314;
    STRING *t_315;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_313 = GET_NCI_P(0);
    t_314 = GET_NCI_I(1);
    t_315 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_313) ? NULL : t_313,t_314,t_315);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JOSP(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_317;
    STRING *t_318;
    PMC *t_319;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_317 = GET_NCI_P(0);
    t_318 = GET_NCI_S(1);
    t_319 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_317) ? NULL : t_317,t_318,PMC_IS_NULL(t_319) ? NULL : t_319);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_(PARROT_INTERP, PMC *self)
{
    int (*pointer)(void);
    int return_data;
    
    call_state st;
    

    pointer =  (int (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (int)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i3i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *, int);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int t_320;
    PMC *t_321;
    int t_322;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_320 = (int)GET_NCI_I(0);
    t_321 = GET_NCI_P(1);
    t_322 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_321);
    return_data =  (int)(*pointer)(t_320,&arg1,t_322);
    PMC_int_val(t_321) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_323;
    STRING *t_324;
    int t_325;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_323 = (int)GET_NCI_I(0);
    t_324 = GET_NCI_S(1);
    t_325 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_323,PObj_bufstart(t_324),t_325);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_lttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    long t_326;
    char *t_327;
    char *t_328;
    long t_329;
    Parrot_init_arg_nci(interp, &st, "ISSI");
    t_326 = (long)GET_NCI_I(0);
    t_327 = string_to_cstring(interp, GET_NCI_S(1));
    t_328 = string_to_cstring(interp, GET_NCI_S(2));
    t_329 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_326,t_327,t_328,t_329);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_327);
    string_cstring_free(t_328);
}
static void
pcf_i_pip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_330;
    int t_331;
    PMC *t_332;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_330 = GET_NCI_P(0);
    t_331 = (int)GET_NCI_I(1);
    t_332 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_330),t_331,PMC_data(t_332));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piS(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, STRING *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_333;
    int t_334;
    STRING *t_335;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_333 = GET_NCI_P(0);
    t_334 = (int)GET_NCI_I(1);
    t_335 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_333),t_334,t_335);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_i(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(int);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    int t_336;
    Parrot_init_arg_nci(interp, &st, "I");
    t_336 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(t_336);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_l_p(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_337;
    Parrot_init_arg_nci(interp, &st, "P");
    t_337 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_337));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_p(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_338;
    Parrot_init_arg_nci(interp, &st, "P");
    t_338 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_338));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_339;
    int t_340;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_339 = GET_NCI_P(0);
    t_340 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_339),t_340);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_p(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_341;
    Parrot_init_arg_nci(interp, &st, "P");
    t_341 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_341));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_pttttt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, char *, char *, char *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_342;
    char *t_343;
    char *t_344;
    char *t_345;
    char *t_346;
    char *t_347;
    Parrot_init_arg_nci(interp, &st, "PSSSSS");
    t_342 = GET_NCI_P(0);
    t_343 = string_to_cstring(interp, GET_NCI_S(1));
    t_344 = string_to_cstring(interp, GET_NCI_S(2));
    t_345 = string_to_cstring(interp, GET_NCI_S(3));
    t_346 = string_to_cstring(interp, GET_NCI_S(4));
    t_347 = string_to_cstring(interp, GET_NCI_S(5));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_342),t_343,t_344,t_345,t_346,t_347);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_343);
    string_cstring_free(t_344);
    string_cstring_free(t_345);
    string_cstring_free(t_346);
    string_cstring_free(t_347);
}
static void
pcf_c_pttt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, char *, char *, char *);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_348;
    char *t_349;
    char *t_350;
    char *t_351;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_348 = GET_NCI_P(0);
    t_349 = string_to_cstring(interp, GET_NCI_S(1));
    t_350 = string_to_cstring(interp, GET_NCI_S(2));
    t_351 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_348),t_349,t_350,t_351);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_349);
    string_cstring_free(t_350);
    string_cstring_free(t_351);
}
static void
pcf_p_pttttiti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_352;
    char *t_353;
    char *t_354;
    char *t_355;
    char *t_356;
    int t_357;
    char *t_358;
    int t_359;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_352 = GET_NCI_P(0);
    t_353 = string_to_cstring(interp, GET_NCI_S(1));
    t_354 = string_to_cstring(interp, GET_NCI_S(2));
    t_355 = string_to_cstring(interp, GET_NCI_S(3));
    t_356 = string_to_cstring(interp, GET_NCI_S(4));
    t_357 = (int)GET_NCI_I(5);
    t_358 = string_to_cstring(interp, GET_NCI_S(6));
    t_359 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_352),t_353,t_354,t_355,t_356,t_357,t_358,t_359);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_353);
    string_cstring_free(t_354);
    string_cstring_free(t_355);
    string_cstring_free(t_356);
    string_cstring_free(t_358);
}
static void
pcf_i_pt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_360;
    char *t_361;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_360 = GET_NCI_P(0);
    t_361 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_360),t_361);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_361);
}
static void
pcf_i_ptl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_362;
    char *t_363;
    long t_364;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_362 = GET_NCI_P(0);
    t_363 = string_to_cstring(interp, GET_NCI_S(1));
    t_364 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_362),t_363,t_364);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_363);
}
static void
pcf_i_pi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_365;
    int t_366;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_365 = GET_NCI_P(0);
    t_366 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_365),t_366);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_367;
    long t_368;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_367 = GET_NCI_P(0);
    t_368 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_367),t_368);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_(PARROT_INTERP, PMC *self)
{
    long (*pointer)(void);
    long return_data;
    
    call_state st;
    

    pointer =  (long (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (long)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_369;
    char *t_370;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_369 = GET_NCI_P(0);
    t_370 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_369),t_370);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_370);
}
static void
pcf_p_ptt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_371;
    char *t_372;
    char *t_373;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_371 = GET_NCI_P(0);
    t_372 = string_to_cstring(interp, GET_NCI_S(1));
    t_373 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_371),t_372,t_373);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_372);
    string_cstring_free(t_373);
}
static void
pcf_i_pit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_374;
    int t_375;
    char *t_376;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_374 = GET_NCI_P(0);
    t_375 = (int)GET_NCI_I(1);
    t_376 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_374),t_375,t_376);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_376);
}
static void
pcf_p_pp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_377;
    PMC *t_378;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_377 = GET_NCI_P(0);
    t_378 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_377),PMC_data(t_378));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_l_ttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    char *t_379;
    char *t_380;
    long t_381;
    Parrot_init_arg_nci(interp, &st, "SSI");
    t_379 = string_to_cstring(interp, GET_NCI_S(0));
    t_380 = string_to_cstring(interp, GET_NCI_S(1));
    t_381 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_379,t_380,t_381);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_379);
    string_cstring_free(t_380);
}
static void
pcf_l_pttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_382;
    char *t_383;
    char *t_384;
    long t_385;
    Parrot_init_arg_nci(interp, &st, "PSSI");
    t_382 = GET_NCI_P(0);
    t_383 = string_to_cstring(interp, GET_NCI_S(1));
    t_384 = string_to_cstring(interp, GET_NCI_S(2));
    t_385 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_382),t_383,t_384,t_385);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_383);
    string_cstring_free(t_384);
}
static void
pcf_v_t(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *);
    func_t pointer;
    call_state st;
    
    
    char *t_386;
    Parrot_init_arg_nci(interp, &st, "S");
    t_386 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_386);
    
    
    string_cstring_free(t_386);
}
static void
pcf_p_tiB3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void **, int *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg3;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_387;
    int t_388;
    STRING *t_389;
    PMC *t_390;
    PMC *t_391;
    Parrot_init_arg_nci(interp, &st, "SISPP");
    t_387 = string_to_cstring(interp, GET_NCI_S(0));
    t_388 = (int)GET_NCI_I(1);
    t_389 = GET_NCI_S(2);
    t_390 = GET_NCI_P(3);
    t_391 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_390);
    return_data =  (void *)(*pointer)(t_387,t_388,&PObj_bufstart(t_389),&arg3,PMC_IS_NULL(t_391) ? NULL : t_391);
    PMC_int_val(t_390) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_387);
}
static void
pcf_p_tip3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void *, int *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg3;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_392;
    int t_393;
    PMC *t_394;
    PMC *t_395;
    PMC *t_396;
    Parrot_init_arg_nci(interp, &st, "SIPPP");
    t_392 = string_to_cstring(interp, GET_NCI_S(0));
    t_393 = (int)GET_NCI_I(1);
    t_394 = GET_NCI_P(2);
    t_395 = GET_NCI_P(3);
    t_396 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_395);
    return_data =  (void *)(*pointer)(t_392,t_393,PMC_data(t_394),&arg3,PMC_IS_NULL(t_396) ? NULL : t_396);
    PMC_int_val(t_395) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_392);
}
static void
pcf_i_pPtiiipi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, PMC *, char *, int, int, int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_397;
    PMC *t_398;
    char *t_399;
    int t_400;
    int t_401;
    int t_402;
    PMC *t_403;
    int t_404;
    Parrot_init_arg_nci(interp, &st, "PPSIIIPI");
    t_397 = GET_NCI_P(0);
    t_398 = GET_NCI_P(1);
    t_399 = string_to_cstring(interp, GET_NCI_S(2));
    t_400 = (int)GET_NCI_I(3);
    t_401 = (int)GET_NCI_I(4);
    t_402 = (int)GET_NCI_I(5);
    t_403 = GET_NCI_P(6);
    t_404 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_397),PMC_IS_NULL(t_398) ? NULL : t_398,t_399,t_400,t_401,t_402,PMC_data(t_403),t_404);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_399);
}
static void
pcf_i_tpiibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *, int, int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_405;
    PMC *t_406;
    int t_407;
    int t_408;
    STRING *t_409;
    int t_410;
    Parrot_init_arg_nci(interp, &st, "SPIISI");
    t_405 = string_to_cstring(interp, GET_NCI_S(0));
    t_406 = GET_NCI_P(1);
    t_407 = (int)GET_NCI_I(2);
    t_408 = (int)GET_NCI_I(3);
    t_409 = GET_NCI_S(4);
    t_410 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_405,PMC_data(t_406),t_407,t_408,PObj_bufstart(t_409),t_410);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_405);
}
static void
pcf_p_ptippppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_411;
    char *t_412;
    int t_413;
    PMC *t_414;
    PMC *t_415;
    PMC *t_416;
    PMC *t_417;
    int t_418;
    Parrot_init_arg_nci(interp, &st, "PSIPPPPI");
    t_411 = GET_NCI_P(0);
    t_412 = string_to_cstring(interp, GET_NCI_S(1));
    t_413 = (int)GET_NCI_I(2);
    t_414 = GET_NCI_P(3);
    t_415 = GET_NCI_P(4);
    t_416 = GET_NCI_P(5);
    t_417 = GET_NCI_P(6);
    t_418 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_411),t_412,t_413,PMC_data(t_414),PMC_data(t_415),PMC_data(t_416),PMC_data(t_417),t_418);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_412);
}
static void
pcf_p_pi33ipi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int *, int *, int, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg2;
    int arg3;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_419;
    int t_420;
    PMC *t_421;
    PMC *t_422;
    int t_423;
    PMC *t_424;
    int t_425;
    Parrot_init_arg_nci(interp, &st, "PIPPIPI");
    t_419 = GET_NCI_P(0);
    t_420 = (int)GET_NCI_I(1);
    t_421 = GET_NCI_P(2);
    t_422 = GET_NCI_P(3);
    t_423 = (int)GET_NCI_I(4);
    t_424 = GET_NCI_P(5);
    t_425 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_421);
    arg3 = PMC_int_val(t_422);
    return_data =  (void *)(*pointer)(PMC_data(t_419),t_420,&arg2,&arg3,t_423,PMC_data(t_424),t_425);
    PMC_int_val(t_421) = arg2;
    PMC_int_val(t_422) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pttip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_426;
    char *t_427;
    char *t_428;
    int t_429;
    PMC *t_430;
    Parrot_init_arg_nci(interp, &st, "PSSIP");
    t_426 = GET_NCI_P(0);
    t_427 = string_to_cstring(interp, GET_NCI_S(1));
    t_428 = string_to_cstring(interp, GET_NCI_S(2));
    t_429 = (int)GET_NCI_I(3);
    t_430 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_426),t_427,t_428,t_429,PMC_data(t_430));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_427);
    string_cstring_free(t_428);
}
static void
pcf_p_ptipppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_431;
    char *t_432;
    int t_433;
    PMC *t_434;
    PMC *t_435;
    PMC *t_436;
    int t_437;
    Parrot_init_arg_nci(interp, &st, "PSIPPPI");
    t_431 = GET_NCI_P(0);
    t_432 = string_to_cstring(interp, GET_NCI_S(1));
    t_433 = (int)GET_NCI_I(2);
    t_434 = GET_NCI_P(3);
    t_435 = GET_NCI_P(4);
    t_436 = GET_NCI_P(5);
    t_437 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_431),t_432,t_433,PMC_data(t_434),PMC_data(t_435),PMC_data(t_436),t_437);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_432);
}
static void
pcf_p_ppP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_438;
    PMC *t_439;
    PMC *t_440;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_438 = GET_NCI_P(0);
    t_439 = GET_NCI_P(1);
    t_440 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_438),PMC_data(t_439),PMC_IS_NULL(t_440) ? NULL : t_440);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiil(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, long);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_441;
    int t_442;
    int t_443;
    long t_444;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_441 = (int)GET_NCI_I(0);
    t_442 = (int)GET_NCI_I(1);
    t_443 = (int)GET_NCI_I(2);
    t_444 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_441,t_442,t_443,t_444);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_445;
    PMC *t_446;
    long t_447;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_445 = GET_NCI_P(0);
    t_446 = GET_NCI_P(1);
    t_447 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_445),PMC_data(t_446),t_447);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_448;
    int t_449;
    PMC *t_450;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_448 = GET_NCI_P(0);
    t_449 = (int)GET_NCI_I(1);
    t_450 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_448),t_449,PMC_data(t_450));
    
    
    
}
static void
pcf_p_pti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_451;
    char *t_452;
    int t_453;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_451 = GET_NCI_P(0);
    t_452 = string_to_cstring(interp, GET_NCI_S(1));
    t_453 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_451),t_452,t_453);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_452);
}
static void
pcf_i_ppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_454;
    PMC *t_455;
    PMC *t_456;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_454 = GET_NCI_P(0);
    t_455 = GET_NCI_P(1);
    t_456 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_454),PMC_data(t_455),PMC_data(t_456));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_457;
    int t_458;
    Parrot_init_arg_nci(interp, &st, "SI");
    t_457 = string_to_cstring(interp, GET_NCI_S(0));
    t_458 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_457,t_458);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_457);
}
static void
pcf_p_ptp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_459;
    char *t_460;
    PMC *t_461;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_459 = GET_NCI_P(0);
    t_460 = string_to_cstring(interp, GET_NCI_S(1));
    t_461 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_459),t_460,PMC_data(t_461));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_460);
}
static void
pcf_i_pt33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg2;
    int arg3;
    PMC *t_462;
    char *t_463;
    PMC *t_464;
    PMC *t_465;
    Parrot_init_arg_nci(interp, &st, "PSPP");
    t_462 = GET_NCI_P(0);
    t_463 = string_to_cstring(interp, GET_NCI_S(1));
    t_464 = GET_NCI_P(2);
    t_465 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_464);
    arg3 = PMC_int_val(t_465);
    return_data =  (int)(*pointer)(PMC_data(t_462),t_463,&arg2,&arg3);
    PMC_int_val(t_464) = arg2;
    PMC_int_val(t_465) = arg3;
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_463);
}
static void
pcf_c_(PARROT_INTERP, PMC *self)
{
    char (*pointer)(void);
    char return_data;
    
    call_state st;
    

    pointer =  (char (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_pi(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_466;
    int t_467;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_466 = GET_NCI_P(0);
    t_467 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_466),t_467);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_d_(PARROT_INTERP, PMC *self)
{
    double (*pointer)(void);
    double return_data;
    
    call_state st;
    

    pointer =  (double (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (double)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_d_d(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(double);
    func_t pointer;
    call_state st;
    double return_data;
    
    double t_468;
    Parrot_init_arg_nci(interp, &st, "N");
    t_468 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(t_468);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_(PARROT_INTERP, PMC *self)
{
    float (*pointer)(void);
    float return_data;
    
    call_state st;
    

    pointer =  (float (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (float)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_ff(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(float, float);
    func_t pointer;
    call_state st;
    float return_data;
    
    float t_469;
    float t_470;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_469 = (float)GET_NCI_N(0);
    t_470 = (float)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_469,t_470);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_is(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(int, short);
    func_t pointer;
    call_state st;
    float return_data;
    
    int t_471;
    short t_472;
    Parrot_init_arg_nci(interp, &st, "II");
    t_471 = (int)GET_NCI_I(0);
    t_472 = (short)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_471,t_472);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_i_b(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    STRING *t_473;
    Parrot_init_arg_nci(interp, &st, "S");
    t_473 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PObj_bufstart(t_473));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_d(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double);
    func_t pointer;
    call_state st;
    int return_data;
    
    double t_474;
    Parrot_init_arg_nci(interp, &st, "N");
    t_474 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_474);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_475;
    Parrot_init_arg_nci(interp, &st, "I");
    t_475 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_475);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_476;
    int t_477;
    Parrot_init_arg_nci(interp, &st, "II");
    t_476 = (int)GET_NCI_I(0);
    t_477 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_476,t_477);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg2;
    int t_478;
    int t_479;
    PMC *t_480;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_478 = (int)GET_NCI_I(0);
    t_479 = (int)GET_NCI_I(1);
    t_480 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_480);
    return_data =  (int)(*pointer)(t_478,t_479,&arg2);
    PMC_int_val(t_480) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg2;
    int t_481;
    int t_482;
    PMC *t_483;
    int t_484;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_481 = (int)GET_NCI_I(0);
    t_482 = (int)GET_NCI_I(1);
    t_483 = GET_NCI_P(2);
    t_484 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_483);
    return_data =  (int)(*pointer)(t_481,t_482,&arg2,t_484);
    PMC_int_val(t_483) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_485;
    int t_486;
    int t_487;
    int t_488;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_485 = (int)GET_NCI_I(0);
    t_486 = (int)GET_NCI_I(1);
    t_487 = (int)GET_NCI_I(2);
    t_488 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_485,t_486,t_487,t_488);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_489;
    int t_490;
    int t_491;
    long t_492;
    short t_493;
    PMC *t_494;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_489 = (int)GET_NCI_I(0);
    t_490 = (int)GET_NCI_I(1);
    t_491 = (int)GET_NCI_I(2);
    t_492 = (long)GET_NCI_I(3);
    t_493 = (short)GET_NCI_I(4);
    t_494 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_489,t_490,t_491,t_492,t_493,PMC_data(t_494));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_495;
    int t_496;
    long t_497;
    Parrot_init_arg_nci(interp, &st, "III");
    t_495 = (int)GET_NCI_I(0);
    t_496 = (int)GET_NCI_I(1);
    t_497 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_495,t_496,t_497);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_498;
    int t_499;
    long t_500;
    int t_501;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_498 = (int)GET_NCI_I(0);
    t_499 = (int)GET_NCI_I(1);
    t_500 = (long)GET_NCI_I(2);
    t_501 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_498,t_499,t_500,t_501);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_502;
    int t_503;
    PMC *t_504;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_502 = (int)GET_NCI_I(0);
    t_503 = (int)GET_NCI_I(1);
    t_504 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_502,t_503,PMC_data(t_504));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_505;
    int t_506;
    char *t_507;
    Parrot_init_arg_nci(interp, &st, "IIS");
    t_505 = (int)GET_NCI_I(0);
    t_506 = (int)GET_NCI_I(1);
    t_507 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_505,t_506,t_507);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_507);
}
static void
pcf_i_iiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_508;
    int t_509;
    char *t_510;
    int t_511;
    Parrot_init_arg_nci(interp, &st, "IISI");
    t_508 = (int)GET_NCI_I(0);
    t_509 = (int)GET_NCI_I(1);
    t_510 = string_to_cstring(interp, GET_NCI_S(2));
    t_511 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_508,t_509,t_510,t_511);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_510);
}
static void
pcf_i_ilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_512;
    long t_513;
    short t_514;
    PMC *t_515;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_512 = (int)GET_NCI_I(0);
    t_513 = (long)GET_NCI_I(1);
    t_514 = (short)GET_NCI_I(2);
    t_515 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_512,t_513,t_514,PMC_data(t_515));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_516;
    char *t_517;
    int t_518;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_516 = (int)GET_NCI_I(0);
    t_517 = string_to_cstring(interp, GET_NCI_S(1));
    t_518 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_516,t_517,t_518);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_517);
}
static void
pcf_i_l(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_519;
    Parrot_init_arg_nci(interp, &st, "I");
    t_519 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_519);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_li(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_520;
    int t_521;
    Parrot_init_arg_nci(interp, &st, "II");
    t_520 = (long)GET_NCI_I(0);
    t_521 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_520,t_521);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_522;
    PMC *t_523;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_522 = (long)GET_NCI_I(0);
    t_523 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_522,PMC_data(t_523));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_524;
    short t_525;
    PMC *t_526;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_524 = (long)GET_NCI_I(0);
    t_525 = (short)GET_NCI_I(1);
    t_526 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_524,t_525,PMC_data(t_526));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    PMC *t_527;
    PMC *t_528;
    PMC *t_529;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_527 = GET_NCI_P(0);
    t_528 = GET_NCI_P(1);
    t_529 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_528);
    arg2 = PMC_int_val(t_529);
    return_data =  (int)(*pointer)(PMC_data(t_527),&arg1,&arg2);
    PMC_int_val(t_528) = arg1;
    PMC_int_val(t_529) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    PMC *t_530;
    PMC *t_531;
    PMC *t_532;
    PMC *t_533;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_530 = GET_NCI_P(0);
    t_531 = GET_NCI_P(1);
    t_532 = GET_NCI_P(2);
    t_533 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_531);
    arg2 = PMC_int_val(t_532);
    arg3 = PMC_int_val(t_533);
    return_data =  (int)(*pointer)(PMC_data(t_530),&arg1,&arg2,&arg3);
    PMC_int_val(t_531) = arg1;
    PMC_int_val(t_532) = arg2;
    PMC_int_val(t_533) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p333333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *, int *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
    int arg6;
    PMC *t_534;
    PMC *t_535;
    PMC *t_536;
    PMC *t_537;
    PMC *t_538;
    PMC *t_539;
    PMC *t_540;
    Parrot_init_arg_nci(interp, &st, "PPPPPPP");
    t_534 = GET_NCI_P(0);
    t_535 = GET_NCI_P(1);
    t_536 = GET_NCI_P(2);
    t_537 = GET_NCI_P(3);
    t_538 = GET_NCI_P(4);
    t_539 = GET_NCI_P(5);
    t_540 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_535);
    arg2 = PMC_int_val(t_536);
    arg3 = PMC_int_val(t_537);
    arg4 = PMC_int_val(t_538);
    arg5 = PMC_int_val(t_539);
    arg6 = PMC_int_val(t_540);
    return_data =  (int)(*pointer)(PMC_data(t_534),&arg1,&arg2,&arg3,&arg4,&arg5,&arg6);
    PMC_int_val(t_535) = arg1;
    PMC_int_val(t_536) = arg2;
    PMC_int_val(t_537) = arg3;
    PMC_int_val(t_538) = arg4;
    PMC_int_val(t_539) = arg5;
    PMC_int_val(t_540) = arg6;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    PMC *t_541;
    PMC *t_542;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_541 = GET_NCI_P(0);
    t_542 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_542);
    return_data =  (int)(*pointer)(PMC_data(t_541),&arg1);
    PMC_int_val(t_542) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, short *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    short arg2;
    PMC *t_543;
    PMC *t_544;
    PMC* t_545;
    PMC *t_546;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_543 = GET_NCI_P(0);
    t_544 = GET_NCI_P(1);
    t_545 = GET_NCI_P(2);
    t_546 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_544);
    arg2 = (short)PMC_int_val(t_545);
    return_data =  (int)(*pointer)(PMC_data(t_543),&arg1,&arg2,PMC_data(t_546));
    PMC_int_val(t_544) = arg1;
    PMC_int_val(t_545) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    PMC *t_547;
    PMC *t_548;
    int t_549;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_547 = GET_NCI_P(0);
    t_548 = GET_NCI_P(1);
    t_549 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_548);
    return_data =  (int)(*pointer)(PMC_data(t_547),&arg1,t_549);
    PMC_int_val(t_548) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pb(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_550;
    STRING *t_551;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_550 = GET_NCI_P(0);
    t_551 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_550),PObj_bufstart(t_551));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_552;
    int t_553;
    int t_554;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_552 = GET_NCI_P(0);
    t_553 = (int)GET_NCI_I(1);
    t_554 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_552),t_553,t_554);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg3;
    PMC *t_555;
    int t_556;
    int t_557;
    PMC *t_558;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_555 = GET_NCI_P(0);
    t_556 = (int)GET_NCI_I(1);
    t_557 = (int)GET_NCI_I(2);
    t_558 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_558);
    return_data =  (int)(*pointer)(PMC_data(t_555),t_556,t_557,&arg3);
    PMC_int_val(t_558) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg3;
    PMC *t_559;
    int t_560;
    int t_561;
    PMC *t_562;
    int t_563;
    Parrot_init_arg_nci(interp, &st, "PIIPI");
    t_559 = GET_NCI_P(0);
    t_560 = (int)GET_NCI_I(1);
    t_561 = (int)GET_NCI_I(2);
    t_562 = GET_NCI_P(3);
    t_563 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_562);
    return_data =  (int)(*pointer)(PMC_data(t_559),t_560,t_561,&arg3,t_563);
    PMC_int_val(t_562) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_564;
    int t_565;
    int t_566;
    int t_567;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_564 = GET_NCI_P(0);
    t_565 = (int)GET_NCI_I(1);
    t_566 = (int)GET_NCI_I(2);
    t_567 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_564),t_565,t_566,t_567);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_568;
    int t_569;
    int t_570;
    int t_571;
    int t_572;
    int t_573;
    int t_574;
    Parrot_init_arg_nci(interp, &st, "PIIIIII");
    t_568 = GET_NCI_P(0);
    t_569 = (int)GET_NCI_I(1);
    t_570 = (int)GET_NCI_I(2);
    t_571 = (int)GET_NCI_I(3);
    t_572 = (int)GET_NCI_I(4);
    t_573 = (int)GET_NCI_I(5);
    t_574 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_568),t_569,t_570,t_571,t_572,t_573,t_574);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_575;
    int t_576;
    int t_577;
    int t_578;
    long t_579;
    short t_580;
    PMC *t_581;
    Parrot_init_arg_nci(interp, &st, "PIIIIIP");
    t_575 = GET_NCI_P(0);
    t_576 = (int)GET_NCI_I(1);
    t_577 = (int)GET_NCI_I(2);
    t_578 = (int)GET_NCI_I(3);
    t_579 = (long)GET_NCI_I(4);
    t_580 = (short)GET_NCI_I(5);
    t_581 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_575),t_576,t_577,t_578,t_579,t_580,PMC_data(t_581));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_582;
    int t_583;
    int t_584;
    long t_585;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_582 = GET_NCI_P(0);
    t_583 = (int)GET_NCI_I(1);
    t_584 = (int)GET_NCI_I(2);
    t_585 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_582),t_583,t_584,t_585);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_586;
    int t_587;
    int t_588;
    long t_589;
    int t_590;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_586 = GET_NCI_P(0);
    t_587 = (int)GET_NCI_I(1);
    t_588 = (int)GET_NCI_I(2);
    t_589 = (long)GET_NCI_I(3);
    t_590 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_586),t_587,t_588,t_589,t_590);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_591;
    int t_592;
    int t_593;
    char *t_594;
    Parrot_init_arg_nci(interp, &st, "PIIS");
    t_591 = GET_NCI_P(0);
    t_592 = (int)GET_NCI_I(1);
    t_593 = (int)GET_NCI_I(2);
    t_594 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_591),t_592,t_593,t_594);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_594);
}
static void
pcf_i_piiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_595;
    int t_596;
    int t_597;
    char *t_598;
    int t_599;
    Parrot_init_arg_nci(interp, &st, "PIISI");
    t_595 = GET_NCI_P(0);
    t_596 = (int)GET_NCI_I(1);
    t_597 = (int)GET_NCI_I(2);
    t_598 = string_to_cstring(interp, GET_NCI_S(3));
    t_599 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_595),t_596,t_597,t_598,t_599);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_598);
}
static void
pcf_i_pilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_600;
    int t_601;
    long t_602;
    short t_603;
    PMC *t_604;
    Parrot_init_arg_nci(interp, &st, "PIIIP");
    t_600 = GET_NCI_P(0);
    t_601 = (int)GET_NCI_I(1);
    t_602 = (long)GET_NCI_I(2);
    t_603 = (short)GET_NCI_I(3);
    t_604 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_600),t_601,t_602,t_603,PMC_data(t_604));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pli(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_605;
    long t_606;
    int t_607;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_605 = GET_NCI_P(0);
    t_606 = (long)GET_NCI_I(1);
    t_607 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_605),t_606,t_607);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_608;
    long t_609;
    long t_610;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_608 = GET_NCI_P(0);
    t_609 = (long)GET_NCI_I(1);
    t_610 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_608),t_609,t_610);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pllllllll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long, long, long, long, long, long, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_611;
    long t_612;
    long t_613;
    long t_614;
    long t_615;
    long t_616;
    long t_617;
    long t_618;
    long t_619;
    Parrot_init_arg_nci(interp, &st, "PIIIIIIII");
    t_611 = GET_NCI_P(0);
    t_612 = (long)GET_NCI_I(1);
    t_613 = (long)GET_NCI_I(2);
    t_614 = (long)GET_NCI_I(3);
    t_615 = (long)GET_NCI_I(4);
    t_616 = (long)GET_NCI_I(5);
    t_617 = (long)GET_NCI_I(6);
    t_618 = (long)GET_NCI_I(7);
    t_619 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_611),t_612,t_613,t_614,t_615,t_616,t_617,t_618,t_619);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_620;
    long t_621;
    PMC *t_622;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_620 = GET_NCI_P(0);
    t_621 = (long)GET_NCI_I(1);
    t_622 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_620),t_621,PMC_data(t_622));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_623;
    long t_624;
    short t_625;
    PMC *t_626;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_623 = GET_NCI_P(0);
    t_624 = (long)GET_NCI_I(1);
    t_625 = (short)GET_NCI_I(2);
    t_626 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_623),t_624,t_625,PMC_data(t_626));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_627;
    PMC *t_628;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_627 = GET_NCI_P(0);
    t_628 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_627),PMC_data(t_628));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_629;
    PMC *t_630;
    int t_631;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_629 = GET_NCI_P(0);
    t_630 = GET_NCI_P(1);
    t_631 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_629),PMC_data(t_630),t_631);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_632;
    PMC *t_633;
    int t_634;
    int t_635;
    int t_636;
    int t_637;
    int t_638;
    int t_639;
    int t_640;
    int t_641;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIIII");
    t_632 = GET_NCI_P(0);
    t_633 = GET_NCI_P(1);
    t_634 = (int)GET_NCI_I(2);
    t_635 = (int)GET_NCI_I(3);
    t_636 = (int)GET_NCI_I(4);
    t_637 = (int)GET_NCI_I(5);
    t_638 = (int)GET_NCI_I(6);
    t_639 = (int)GET_NCI_I(7);
    t_640 = (int)GET_NCI_I(8);
    t_641 = (int)GET_NCI_I(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_632),PMC_data(t_633),t_634,t_635,t_636,t_637,t_638,t_639,t_640,t_641);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_642;
    PMC *t_643;
    PMC *t_644;
    PMC *t_645;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_642 = GET_NCI_P(0);
    t_643 = GET_NCI_P(1);
    t_644 = GET_NCI_P(2);
    t_645 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_642),PMC_data(t_643),PMC_data(t_644),PMC_data(t_645));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_psp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_646;
    short t_647;
    PMC *t_648;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_646 = GET_NCI_P(0);
    t_647 = (short)GET_NCI_I(1);
    t_648 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_646),t_647,PMC_data(t_648));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_649;
    char *t_650;
    int t_651;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_649 = GET_NCI_P(0);
    t_650 = string_to_cstring(interp, GET_NCI_S(1));
    t_651 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_649),t_650,t_651);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_650);
}
static void
pcf_i_pitl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_652;
    int t_653;
    char *t_654;
    long t_655;
    Parrot_init_arg_nci(interp, &st, "PISI");
    t_652 = GET_NCI_P(0);
    t_653 = (int)GET_NCI_I(1);
    t_654 = string_to_cstring(interp, GET_NCI_S(2));
    t_655 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_652),t_653,t_654,t_655);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_654);
}
static void
pcf_i_s(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_656;
    Parrot_init_arg_nci(interp, &st, "I");
    t_656 = (short)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_656);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_s22(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *);
    func_t pointer;
    call_state st;
    int return_data;
    short arg1;
    short arg2;
    short t_657;
    PMC* t_658;
    PMC* t_659;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_657 = (short)GET_NCI_I(0);
    t_658 = GET_NCI_P(1);
    t_659 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_658);
    arg2 = (short)PMC_int_val(t_659);
    return_data =  (int)(*pointer)(t_657,&arg1,&arg2);
    PMC_int_val(t_658) = arg1;
    PMC_int_val(t_659) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_s222(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *, short *);
    func_t pointer;
    call_state st;
    int return_data;
    short arg1;
    short arg2;
    short arg3;
    short t_660;
    PMC* t_661;
    PMC* t_662;
    PMC* t_663;
    Parrot_init_arg_nci(interp, &st, "IPPP");
    t_660 = (short)GET_NCI_I(0);
    t_661 = GET_NCI_P(1);
    t_662 = GET_NCI_P(2);
    t_663 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_661);
    arg2 = (short)PMC_int_val(t_662);
    arg3 = (short)PMC_int_val(t_663);
    return_data =  (int)(*pointer)(t_660,&arg1,&arg2,&arg3);
    PMC_int_val(t_661) = arg1;
    PMC_int_val(t_662) = arg2;
    PMC_int_val(t_663) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_664;
    PMC *t_665;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_664 = (short)GET_NCI_I(0);
    t_665 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_664,PMC_data(t_665));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_666;
    short t_667;
    short t_668;
    Parrot_init_arg_nci(interp, &st, "III");
    t_666 = (short)GET_NCI_I(0);
    t_667 = (short)GET_NCI_I(1);
    t_668 = (short)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_666,t_667,t_668);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ssss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short, short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_669;
    short t_670;
    short t_671;
    short t_672;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_669 = (short)GET_NCI_I(0);
    t_670 = (short)GET_NCI_I(1);
    t_671 = (short)GET_NCI_I(2);
    t_672 = (short)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_669,t_670,t_671,t_672);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_t(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_673;
    Parrot_init_arg_nci(interp, &st, "S");
    t_673 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_673);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_673);
}
static void
pcf_i_ti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_674;
    int t_675;
    Parrot_init_arg_nci(interp, &st, "SI");
    t_674 = string_to_cstring(interp, GET_NCI_S(0));
    t_675 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_674,t_675);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_674);
}
static void
pcf_i_4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    PMC *t_676;
    Parrot_init_arg_nci(interp, &st, "P");
    t_676 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_676);
    return_data =  (int)(*pointer)(&arg0);
    PMC_int_val(t_676) = arg0;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    PMC *t_677;
    int t_678;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_677 = GET_NCI_P(0);
    t_678 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_677);
    return_data =  (int)(*pointer)(&arg0,t_678);
    PMC_int_val(t_677) = arg0;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, short *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    short arg1;
    PMC *t_679;
    PMC* t_680;
    PMC *t_681;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_679 = GET_NCI_P(0);
    t_680 = GET_NCI_P(1);
    t_681 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_679);
    arg1 = (short)PMC_int_val(t_680);
    return_data =  (int)(*pointer)(&arg0,&arg1,PMC_data(t_681));
    PMC_int_val(t_679) = arg0;
    PMC_int_val(t_680) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    int t_682;
    int t_683;
    Parrot_init_arg_nci(interp, &st, "II");
    t_682 = (int)GET_NCI_I(0);
    t_683 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_682,t_683);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_l4(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, long *);
    func_t pointer;
    call_state st;
    long return_data;
    long arg1;
    long t_684;
    PMC *t_685;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_684 = (long)GET_NCI_I(0);
    t_685 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_685);
    return_data =  (long)(*pointer)(t_684,&arg1);
    PMC_int_val(t_685) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pi(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_686;
    int t_687;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_686 = GET_NCI_P(0);
    t_687 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_686),t_687);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_688;
    int t_689;
    int t_690;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_688 = GET_NCI_P(0);
    t_689 = (int)GET_NCI_I(1);
    t_690 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_688),t_689,t_690);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_p33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int *, int *, long);
    func_t pointer;
    call_state st;
    long return_data;
    int arg1;
    int arg2;
    PMC *t_691;
    PMC *t_692;
    PMC *t_693;
    long t_694;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_691 = GET_NCI_P(0);
    t_692 = GET_NCI_P(1);
    t_693 = GET_NCI_P(2);
    t_694 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_692);
    arg2 = PMC_int_val(t_693);
    return_data =  (long)(*pointer)(PMC_data(t_691),&arg1,&arg2,t_694);
    PMC_int_val(t_692) = arg1;
    PMC_int_val(t_693) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int *, int *, long);
    func_t pointer;
    call_state st;
    long return_data;
    int arg0;
    int arg1;
    PMC *t_695;
    PMC *t_696;
    long t_697;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_695 = GET_NCI_P(0);
    t_696 = GET_NCI_P(1);
    t_697 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_695);
    arg1 = PMC_int_val(t_696);
    return_data =  (long)(*pointer)(&arg0,&arg1,t_697);
    PMC_int_val(t_695) = arg0;
    PMC_int_val(t_696) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_(PARROT_INTERP, PMC *self)
{
    void * (*pointer)(void);
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    call_state st;
    

    pointer =  (void * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (void *)(*pointer)();
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_B(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void **);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_698;
    Parrot_init_arg_nci(interp, &st, "S");
    t_698 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(&PObj_bufstart(t_698));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_b(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_699;
    Parrot_init_arg_nci(interp, &st, "S");
    t_699 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PObj_bufstart(t_699));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_701;
    Parrot_init_arg_nci(interp, &st, "S");
    t_701 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_701);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_701);
}
static void
pcf_p_i(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_702;
    Parrot_init_arg_nci(interp, &st, "I");
    t_702 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_702);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_703;
    int t_704;
    Parrot_init_arg_nci(interp, &st, "II");
    t_703 = (int)GET_NCI_I(0);
    t_704 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_703,t_704);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_705;
    int t_706;
    int t_707;
    int t_708;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_705 = (int)GET_NCI_I(0);
    t_706 = (int)GET_NCI_I(1);
    t_707 = (int)GET_NCI_I(2);
    t_708 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_705,t_706,t_707,t_708);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_709;
    int t_710;
    int t_711;
    int t_712;
    int t_713;
    int t_714;
    Parrot_init_arg_nci(interp, &st, "IIIIII");
    t_709 = (int)GET_NCI_I(0);
    t_710 = (int)GET_NCI_I(1);
    t_711 = (int)GET_NCI_I(2);
    t_712 = (int)GET_NCI_I(3);
    t_713 = (int)GET_NCI_I(4);
    t_714 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_709,t_710,t_711,t_712,t_713,t_714);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_715;
    int t_716;
    int t_717;
    int t_718;
    int t_719;
    int t_720;
    int t_721;
    int t_722;
    Parrot_init_arg_nci(interp, &st, "IIIIIIII");
    t_715 = (int)GET_NCI_I(0);
    t_716 = (int)GET_NCI_I(1);
    t_717 = (int)GET_NCI_I(2);
    t_718 = (int)GET_NCI_I(3);
    t_719 = (int)GET_NCI_I(4);
    t_720 = (int)GET_NCI_I(5);
    t_721 = (int)GET_NCI_I(6);
    t_722 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_715,t_716,t_717,t_718,t_719,t_720,t_721,t_722);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_723;
    int t_724;
    int t_725;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_723 = GET_NCI_P(0);
    t_724 = (int)GET_NCI_I(1);
    t_725 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_723),t_724,t_725);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_piiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_726;
    int t_727;
    int t_728;
    int t_729;
    int t_730;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_726 = GET_NCI_P(0);
    t_727 = (int)GET_NCI_I(1);
    t_728 = (int)GET_NCI_I(2);
    t_729 = (int)GET_NCI_I(3);
    t_730 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_726),t_727,t_728,t_729,t_730);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_t(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_731;
    Parrot_init_arg_nci(interp, &st, "S");
    t_731 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_731);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_731);
}
static void
pcf_p_tpp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_732;
    PMC *t_733;
    PMC *t_734;
    Parrot_init_arg_nci(interp, &st, "SPP");
    t_732 = string_to_cstring(interp, GET_NCI_S(0));
    t_733 = GET_NCI_P(1);
    t_734 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_732,PMC_data(t_733),PMC_data(t_734));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_732);
}
static void
pcf_p_ttttttt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, char *, char *, char *, char *, char *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_735;
    char *t_736;
    char *t_737;
    char *t_738;
    char *t_739;
    char *t_740;
    char *t_741;
    Parrot_init_arg_nci(interp, &st, "SSSSSSS");
    t_735 = string_to_cstring(interp, GET_NCI_S(0));
    t_736 = string_to_cstring(interp, GET_NCI_S(1));
    t_737 = string_to_cstring(interp, GET_NCI_S(2));
    t_738 = string_to_cstring(interp, GET_NCI_S(3));
    t_739 = string_to_cstring(interp, GET_NCI_S(4));
    t_740 = string_to_cstring(interp, GET_NCI_S(5));
    t_741 = string_to_cstring(interp, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_735,t_736,t_737,t_738,t_739,t_740,t_741);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_735);
    string_cstring_free(t_736);
    string_cstring_free(t_737);
    string_cstring_free(t_738);
    string_cstring_free(t_739);
    string_cstring_free(t_740);
    string_cstring_free(t_741);
}
static void
pcf_s_(PARROT_INTERP, PMC *self)
{
    short (*pointer)(void);
    short return_data;
    
    call_state st;
    

    pointer =  (short (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (short)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_(PARROT_INTERP, PMC *self)
{
    char * (*pointer)(void);
    char * return_data;
    STRING *final_destination;
    call_state st;
    

    pointer =  (char * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char *)(*pointer)();
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_i(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;int t_742;
    Parrot_init_arg_nci(interp, &st, "I");
    t_742 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_742);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_ii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;int t_743;
    int t_744;
    Parrot_init_arg_nci(interp, &st, "II");
    t_743 = (int)GET_NCI_I(0);
    t_744 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_743,t_744);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pi(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_745;
    int t_746;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_745 = GET_NCI_P(0);
    t_746 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_745),t_746);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_747;
    int t_748;
    int t_749;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_747 = GET_NCI_P(0);
    t_748 = (int)GET_NCI_I(1);
    t_749 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_747),t_748,t_749);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_t(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_750;
    Parrot_init_arg_nci(interp, &st, "S");
    t_750 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_750);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_750);
}
static void
pcf_t_tl4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long, long *);
    func_t pointer;
    call_state st;
    char * return_data;
    long arg2;
    STRING *final_destination;char *t_751;
    long t_752;
    PMC *t_753;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_751 = string_to_cstring(interp, GET_NCI_S(0));
    t_752 = (long)GET_NCI_I(1);
    t_753 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_753);
    return_data =  (char *)(*pointer)(t_751,t_752,&arg2);
    PMC_int_val(t_753) = arg2;
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_751);
}
static void
pcf_t_t4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long *);
    func_t pointer;
    call_state st;
    char * return_data;
    long arg1;
    STRING *final_destination;char *t_754;
    PMC *t_755;
    Parrot_init_arg_nci(interp, &st, "SP");
    t_754 = string_to_cstring(interp, GET_NCI_S(0));
    t_755 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_755);
    return_data =  (char *)(*pointer)(t_754,&arg1);
    PMC_int_val(t_755) = arg1;
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_754);
}
static void
pcf_i_sc(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, char);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_756;
    char t_757;
    Parrot_init_arg_nci(interp, &st, "II");
    t_756 = (short)GET_NCI_I(0);
    t_757 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_756,t_757);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_s_sc(PARROT_INTERP, PMC *self)
{
    typedef short (*func_t)(short, char);
    func_t pointer;
    call_state st;
    short return_data;
    
    short t_758;
    char t_759;
    Parrot_init_arg_nci(interp, &st, "II");
    t_758 = (short)GET_NCI_I(0);
    t_759 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (short)(*pointer)(t_758,t_759);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_sc(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(short, char);
    func_t pointer;
    call_state st;
    char return_data;
    
    short t_760;
    char t_761;
    Parrot_init_arg_nci(interp, &st, "II");
    t_760 = (short)GET_NCI_I(0);
    t_761 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_760,t_761);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_762;
    int t_763;
    int t_764;
    Parrot_init_arg_nci(interp, &st, "III");
    t_762 = (int)GET_NCI_I(0);
    t_763 = (int)GET_NCI_I(1);
    t_764 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_762,t_763,t_764);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i3(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int t_765;
    PMC *t_766;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_765 = (int)GET_NCI_I(0);
    t_766 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_766);
    return_data =  (int)(*pointer)(t_765,&arg1);
    PMC_int_val(t_766) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_b(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_767;
    Parrot_init_arg_nci(interp, &st, "S");
    t_767 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PObj_bufstart(t_767));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_B(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void **);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_768;
    Parrot_init_arg_nci(interp, &st, "S");
    t_768 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(&PObj_bufstart(t_768));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_v_P(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_769;
    Parrot_init_arg_nci(interp, &st, "P");
    t_769 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_IS_NULL(t_769) ? NULL : t_769);
    
    
    
}
static void
pcf_v_pP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_770;
    PMC *t_771;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_770 = GET_NCI_P(0);
    t_771 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_770),PMC_IS_NULL(t_771) ? NULL : t_771);
    
    
    
}
static void
pcf_p_ip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_772;
    PMC *t_773;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_772 = (int)GET_NCI_I(0);
    t_773 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_772,PMC_data(t_773));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg0;
    int arg1;
    PMC *t_774;
    PMC *t_775;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_774 = GET_NCI_P(0);
    t_775 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_774);
    arg1 = PMC_int_val(t_775);
    return_data =  (int)(*pointer)(&arg0,&arg1);
    PMC_int_val(t_774) = arg0;
    PMC_int_val(t_775) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_776;
    int t_777;
    int t_778;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_776 = GET_NCI_P(0);
    t_777 = (int)GET_NCI_I(1);
    t_778 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_776),t_777,t_778);
    
    
    
}
static void
pcf_v_JO(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_780;
    Parrot_init_arg_nci(interp, &st, "P");
    t_780 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_780) ? NULL : t_780);
    
    
    
}
static void
pcf_i_JO(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_782;
    Parrot_init_arg_nci(interp, &st, "P");
    t_782 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_782) ? NULL : t_782);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_784;
    int t_785;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_784 = GET_NCI_P(0);
    t_785 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_784) ? NULL : t_784,t_785);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_787;
    char *t_788;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_787 = GET_NCI_P(0);
    t_788 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_787) ? NULL : t_787,t_788);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_788);
}
static void
pcf_i_Jt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_790;
    Parrot_init_arg_nci(interp, &st, "S");
    t_790 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,t_790);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_790);
}
static void
pcf_i_Ji(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_792;
    Parrot_init_arg_nci(interp, &st, "I");
    t_792 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,t_792);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JPi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_794;
    int t_795;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_794 = GET_NCI_P(0);
    t_795 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_794) ? NULL : t_794,t_795);
    
    
    
}
static void
pcf_v_JPii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_797;
    int t_798;
    int t_799;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_797 = GET_NCI_P(0);
    t_798 = (int)GET_NCI_I(1);
    t_799 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_797) ? NULL : t_797,t_798,t_799);
    
    
    
}
static void
pcf_c_i(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(int);
    func_t pointer;
    call_state st;
    char return_data;
    
    int t_800;
    Parrot_init_arg_nci(interp, &st, "I");
    t_800 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_800);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_ii(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(int, int);
    func_t pointer;
    call_state st;
    char return_data;
    
    int t_801;
    int t_802;
    Parrot_init_arg_nci(interp, &st, "II");
    t_801 = (int)GET_NCI_I(0);
    t_802 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_801,t_802);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_ipt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(int, void *, char *);
    func_t pointer;
    call_state st;
    char return_data;
    
    int t_803;
    PMC *t_804;
    char *t_805;
    Parrot_init_arg_nci(interp, &st, "IPS");
    t_803 = (int)GET_NCI_I(0);
    t_804 = GET_NCI_P(1);
    t_805 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_803,PMC_data(t_804),t_805);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_805);
}
static void
pcf_c_tt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(char *, char *);
    func_t pointer;
    call_state st;
    char return_data;
    
    char *t_806;
    char *t_807;
    Parrot_init_arg_nci(interp, &st, "SS");
    t_806 = string_to_cstring(interp, GET_NCI_S(0));
    t_807 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_806,t_807);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_806);
    string_cstring_free(t_807);
}
static void
pcf_f_ii(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(int, int);
    func_t pointer;
    call_state st;
    float return_data;
    
    int t_808;
    int t_809;
    Parrot_init_arg_nci(interp, &st, "II");
    t_808 = (int)GET_NCI_I(0);
    t_809 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_808,t_809);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_i_ddddpppddpppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double, double, double, double, void *, void *, void *, double, double, void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    double t_810;
    double t_811;
    double t_812;
    double t_813;
    PMC *t_814;
    PMC *t_815;
    PMC *t_816;
    double t_817;
    double t_818;
    PMC *t_819;
    PMC *t_820;
    PMC *t_821;
    PMC *t_822;
    Parrot_init_arg_nci(interp, &st, "NNNNPPPNNPPPP");
    t_810 = (double)GET_NCI_N(0);
    t_811 = (double)GET_NCI_N(1);
    t_812 = (double)GET_NCI_N(2);
    t_813 = (double)GET_NCI_N(3);
    t_814 = GET_NCI_P(4);
    t_815 = GET_NCI_P(5);
    t_816 = GET_NCI_P(6);
    t_817 = (double)GET_NCI_N(7);
    t_818 = (double)GET_NCI_N(8);
    t_819 = GET_NCI_P(9);
    t_820 = GET_NCI_P(10);
    t_821 = GET_NCI_P(11);
    t_822 = GET_NCI_P(12);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_810,t_811,t_812,t_813,PMC_data(t_814),PMC_data(t_815),PMC_data(t_816),t_817,t_818,PMC_data(t_819),PMC_data(t_820),PMC_data(t_821),PMC_data(t_822));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_dddpppppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double, double, double, void *, void *, void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    double t_823;
    double t_824;
    double t_825;
    PMC *t_826;
    PMC *t_827;
    PMC *t_828;
    PMC *t_829;
    PMC *t_830;
    PMC *t_831;
    Parrot_init_arg_nci(interp, &st, "NNNPPPPPP");
    t_823 = (double)GET_NCI_N(0);
    t_824 = (double)GET_NCI_N(1);
    t_825 = (double)GET_NCI_N(2);
    t_826 = GET_NCI_P(3);
    t_827 = GET_NCI_P(4);
    t_828 = GET_NCI_P(5);
    t_829 = GET_NCI_P(6);
    t_830 = GET_NCI_P(7);
    t_831 = GET_NCI_P(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_823,t_824,t_825,PMC_data(t_826),PMC_data(t_827),PMC_data(t_828),PMC_data(t_829),PMC_data(t_830),PMC_data(t_831));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_832;
    int t_833;
    int t_834;
    int t_835;
    int t_836;
    Parrot_init_arg_nci(interp, &st, "IIIII");
    t_832 = (int)GET_NCI_I(0);
    t_833 = (int)GET_NCI_I(1);
    t_834 = (int)GET_NCI_I(2);
    t_835 = (int)GET_NCI_I(3);
    t_836 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_832,t_833,t_834,t_835,t_836);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_837;
    int t_838;
    int t_839;
    int t_840;
    int t_841;
    int t_842;
    int t_843;
    int t_844;
    int t_845;
    int t_846;
    PMC *t_847;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIIP");
    t_837 = (int)GET_NCI_I(0);
    t_838 = (int)GET_NCI_I(1);
    t_839 = (int)GET_NCI_I(2);
    t_840 = (int)GET_NCI_I(3);
    t_841 = (int)GET_NCI_I(4);
    t_842 = (int)GET_NCI_I(5);
    t_843 = (int)GET_NCI_I(6);
    t_844 = (int)GET_NCI_I(7);
    t_845 = (int)GET_NCI_I(8);
    t_846 = (int)GET_NCI_I(9);
    t_847 = GET_NCI_P(10);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_837,t_838,t_839,t_840,t_841,t_842,t_843,t_844,t_845,t_846,PMC_data(t_847));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_848;
    int t_849;
    int t_850;
    int t_851;
    int t_852;
    int t_853;
    int t_854;
    int t_855;
    int t_856;
    PMC *t_857;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIP");
    t_848 = (int)GET_NCI_I(0);
    t_849 = (int)GET_NCI_I(1);
    t_850 = (int)GET_NCI_I(2);
    t_851 = (int)GET_NCI_I(3);
    t_852 = (int)GET_NCI_I(4);
    t_853 = (int)GET_NCI_I(5);
    t_854 = (int)GET_NCI_I(6);
    t_855 = (int)GET_NCI_I(7);
    t_856 = (int)GET_NCI_I(8);
    t_857 = GET_NCI_P(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_848,t_849,t_850,t_851,t_852,t_853,t_854,t_855,t_856,PMC_data(t_857));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_858;
    int t_859;
    int t_860;
    int t_861;
    int t_862;
    int t_863;
    int t_864;
    int t_865;
    PMC *t_866;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIP");
    t_858 = (int)GET_NCI_I(0);
    t_859 = (int)GET_NCI_I(1);
    t_860 = (int)GET_NCI_I(2);
    t_861 = (int)GET_NCI_I(3);
    t_862 = (int)GET_NCI_I(4);
    t_863 = (int)GET_NCI_I(5);
    t_864 = (int)GET_NCI_I(6);
    t_865 = (int)GET_NCI_I(7);
    t_866 = GET_NCI_P(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_858,t_859,t_860,t_861,t_862,t_863,t_864,t_865,PMC_data(t_866));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_867;
    int t_868;
    int t_869;
    int t_870;
    int t_871;
    int t_872;
    int t_873;
    PMC *t_874;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIP");
    t_867 = (int)GET_NCI_I(0);
    t_868 = (int)GET_NCI_I(1);
    t_869 = (int)GET_NCI_I(2);
    t_870 = (int)GET_NCI_I(3);
    t_871 = (int)GET_NCI_I(4);
    t_872 = (int)GET_NCI_I(5);
    t_873 = (int)GET_NCI_I(6);
    t_874 = GET_NCI_P(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_867,t_868,t_869,t_870,t_871,t_872,t_873,PMC_data(t_874));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_875;
    int t_876;
    int t_877;
    int t_878;
    int t_879;
    int t_880;
    PMC *t_881;
    Parrot_init_arg_nci(interp, &st, "IIIIIIP");
    t_875 = (int)GET_NCI_I(0);
    t_876 = (int)GET_NCI_I(1);
    t_877 = (int)GET_NCI_I(2);
    t_878 = (int)GET_NCI_I(3);
    t_879 = (int)GET_NCI_I(4);
    t_880 = (int)GET_NCI_I(5);
    t_881 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_875,t_876,t_877,t_878,t_879,t_880,PMC_data(t_881));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_882;
    int t_883;
    int t_884;
    int t_885;
    int t_886;
    PMC *t_887;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_882 = (int)GET_NCI_I(0);
    t_883 = (int)GET_NCI_I(1);
    t_884 = (int)GET_NCI_I(2);
    t_885 = (int)GET_NCI_I(3);
    t_886 = (int)GET_NCI_I(4);
    t_887 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_882,t_883,t_884,t_885,t_886,PMC_data(t_887));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiiipiiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int, void *, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_888;
    int t_889;
    int t_890;
    int t_891;
    PMC *t_892;
    int t_893;
    int t_894;
    int t_895;
    PMC *t_896;
    Parrot_init_arg_nci(interp, &st, "IIIIPIIIP");
    t_888 = (int)GET_NCI_I(0);
    t_889 = (int)GET_NCI_I(1);
    t_890 = (int)GET_NCI_I(2);
    t_891 = (int)GET_NCI_I(3);
    t_892 = GET_NCI_P(4);
    t_893 = (int)GET_NCI_I(5);
    t_894 = (int)GET_NCI_I(6);
    t_895 = (int)GET_NCI_I(7);
    t_896 = GET_NCI_P(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_888,t_889,t_890,t_891,PMC_data(t_892),t_893,t_894,t_895,PMC_data(t_896));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ipi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_897;
    PMC *t_898;
    int t_899;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_897 = (int)GET_NCI_I(0);
    t_898 = GET_NCI_P(1);
    t_899 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_897,PMC_data(t_898),t_899);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_it(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_900;
    char *t_901;
    Parrot_init_arg_nci(interp, &st, "IS");
    t_900 = (int)GET_NCI_I(0);
    t_901 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_900,t_901);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_901);
}
static void
pcf_i_piiip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_902;
    int t_903;
    int t_904;
    int t_905;
    PMC *t_906;
    Parrot_init_arg_nci(interp, &st, "PIIIP");
    t_902 = GET_NCI_P(0);
    t_903 = (int)GET_NCI_I(1);
    t_904 = (int)GET_NCI_I(2);
    t_905 = (int)GET_NCI_I(3);
    t_906 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_902),t_903,t_904,t_905,PMC_data(t_906));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiipp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_907;
    int t_908;
    int t_909;
    int t_910;
    PMC *t_911;
    PMC *t_912;
    Parrot_init_arg_nci(interp, &st, "PIIIPP");
    t_907 = GET_NCI_P(0);
    t_908 = (int)GET_NCI_I(1);
    t_909 = (int)GET_NCI_I(2);
    t_910 = (int)GET_NCI_I(3);
    t_911 = GET_NCI_P(4);
    t_912 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_907),t_908,t_909,t_910,PMC_data(t_911),PMC_data(t_912));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piipp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_913;
    int t_914;
    int t_915;
    PMC *t_916;
    PMC *t_917;
    Parrot_init_arg_nci(interp, &st, "PIIPP");
    t_913 = GET_NCI_P(0);
    t_914 = (int)GET_NCI_I(1);
    t_915 = (int)GET_NCI_I(2);
    t_916 = GET_NCI_P(3);
    t_917 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_913),t_914,t_915,PMC_data(t_916),PMC_data(t_917));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piipppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_918;
    int t_919;
    int t_920;
    PMC *t_921;
    PMC *t_922;
    PMC *t_923;
    PMC *t_924;
    Parrot_init_arg_nci(interp, &st, "PIIPPPP");
    t_918 = GET_NCI_P(0);
    t_919 = (int)GET_NCI_I(1);
    t_920 = (int)GET_NCI_I(2);
    t_921 = GET_NCI_P(3);
    t_922 = GET_NCI_P(4);
    t_923 = GET_NCI_P(5);
    t_924 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_918),t_919,t_920,PMC_data(t_921),PMC_data(t_922),PMC_data(t_923),PMC_data(t_924));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_925;
    long t_926;
    int t_927;
    PMC *t_928;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_925 = GET_NCI_P(0);
    t_926 = (long)GET_NCI_I(1);
    t_927 = (int)GET_NCI_I(2);
    t_928 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_925),t_926,t_927,PMC_data(t_928));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pllp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_929;
    long t_930;
    long t_931;
    PMC *t_932;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_929 = GET_NCI_P(0);
    t_930 = (long)GET_NCI_I(1);
    t_931 = (long)GET_NCI_I(2);
    t_932 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_929),t_930,t_931,PMC_data(t_932));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plpp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_933;
    long t_934;
    PMC *t_935;
    PMC *t_936;
    Parrot_init_arg_nci(interp, &st, "PIPP");
    t_933 = GET_NCI_P(0);
    t_934 = (long)GET_NCI_I(1);
    t_935 = GET_NCI_P(2);
    t_936 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_933),t_934,PMC_data(t_935),PMC_data(t_936));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_937;
    long t_938;
    PMC *t_939;
    PMC *t_940;
    PMC *t_941;
    Parrot_init_arg_nci(interp, &st, "PIPPP");
    t_937 = GET_NCI_P(0);
    t_938 = (long)GET_NCI_I(1);
    t_939 = GET_NCI_P(2);
    t_940 = GET_NCI_P(3);
    t_941 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_937),t_938,PMC_data(t_939),PMC_data(t_940),PMC_data(t_941));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_942;
    PMC *t_943;
    int t_944;
    PMC *t_945;
    Parrot_init_arg_nci(interp, &st, "PPIP");
    t_942 = GET_NCI_P(0);
    t_943 = GET_NCI_P(1);
    t_944 = (int)GET_NCI_I(2);
    t_945 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_942),PMC_data(t_943),t_944,PMC_data(t_945));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ppiip(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, void *, int, int, void *);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_946;
    PMC *t_947;
    int t_948;
    int t_949;
    PMC *t_950;
    Parrot_init_arg_nci(interp, &st, "PPIIP");
    t_946 = GET_NCI_P(0);
    t_947 = GET_NCI_P(1);
    t_948 = (int)GET_NCI_I(2);
    t_949 = (int)GET_NCI_I(3);
    t_950 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_946),PMC_data(t_947),t_948,t_949,PMC_data(t_950));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ppl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, void *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_951;
    PMC *t_952;
    long t_953;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_951 = GET_NCI_P(0);
    t_952 = GET_NCI_P(1);
    t_953 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_951),PMC_data(t_952),t_953);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ppll(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, void *, long, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_954;
    PMC *t_955;
    long t_956;
    long t_957;
    Parrot_init_arg_nci(interp, &st, "PPII");
    t_954 = GET_NCI_P(0);
    t_955 = GET_NCI_P(1);
    t_956 = (long)GET_NCI_I(2);
    t_957 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_954),PMC_data(t_955),t_956,t_957);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pplp(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, void *, long, void *);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_958;
    PMC *t_959;
    long t_960;
    PMC *t_961;
    Parrot_init_arg_nci(interp, &st, "PPIP");
    t_958 = GET_NCI_P(0);
    t_959 = GET_NCI_P(1);
    t_960 = (long)GET_NCI_I(2);
    t_961 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_958),PMC_data(t_959),t_960,PMC_data(t_961));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ppp(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, void *, void *);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_962;
    PMC *t_963;
    PMC *t_964;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_962 = GET_NCI_P(0);
    t_963 = GET_NCI_P(1);
    t_964 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_962),PMC_data(t_963),PMC_data(t_964));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ifff(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, float, float, float);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_965;
    float t_966;
    float t_967;
    float t_968;
    Parrot_init_arg_nci(interp, &st, "INNN");
    t_965 = (int)GET_NCI_I(0);
    t_966 = (float)GET_NCI_N(1);
    t_967 = (float)GET_NCI_N(2);
    t_968 = (float)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_965,t_966,t_967,t_968);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pilfff(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, long, float, float, float);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_969;
    int t_970;
    long t_971;
    float t_972;
    float t_973;
    float t_974;
    Parrot_init_arg_nci(interp, &st, "PIINNN");
    t_969 = GET_NCI_P(0);
    t_970 = (int)GET_NCI_I(1);
    t_971 = (long)GET_NCI_I(2);
    t_972 = (float)GET_NCI_N(3);
    t_973 = (float)GET_NCI_N(4);
    t_974 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_969),t_970,t_971,t_972,t_973,t_974);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_975;
    int t_976;
    PMC *t_977;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_975 = GET_NCI_P(0);
    t_976 = (int)GET_NCI_I(1);
    t_977 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_975),t_976,PMC_data(t_977));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pipp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_978;
    int t_979;
    PMC *t_980;
    PMC *t_981;
    Parrot_init_arg_nci(interp, &st, "PIPP");
    t_978 = GET_NCI_P(0);
    t_979 = (int)GET_NCI_I(1);
    t_980 = GET_NCI_P(2);
    t_981 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_978),t_979,PMC_data(t_980),PMC_data(t_981));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pl(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, long);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_982;
    long t_983;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_982 = GET_NCI_P(0);
    t_983 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_982),t_983);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ppipi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, int, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_984;
    PMC *t_985;
    int t_986;
    PMC *t_987;
    int t_988;
    Parrot_init_arg_nci(interp, &st, "PPIPI");
    t_984 = GET_NCI_P(0);
    t_985 = GET_NCI_P(1);
    t_986 = (int)GET_NCI_I(2);
    t_987 = GET_NCI_P(3);
    t_988 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_984),PMC_data(t_985),t_986,PMC_data(t_987),t_988);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_989;
    PMC *t_990;
    PMC *t_991;
    int t_992;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_989 = GET_NCI_P(0);
    t_990 = GET_NCI_P(1);
    t_991 = GET_NCI_P(2);
    t_992 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_989),PMC_data(t_990),PMC_data(t_991),t_992);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_3p(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int *, void *);
    func_t pointer;
    call_state st;
    
    int arg0;
    PMC *t_993;
    PMC *t_994;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_993 = GET_NCI_P(0);
    t_994 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_993);
     (void)(*pointer)(&arg0,PMC_data(t_994));
    PMC_int_val(t_993) = arg0;
    
    
}
static void
pcf_v_c(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char);
    func_t pointer;
    call_state st;
    
    
    char t_995;
    Parrot_init_arg_nci(interp, &st, "I");
    t_995 = (char)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_995);
    
    
    
}
static void
pcf_v_ccc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char, char, char);
    func_t pointer;
    call_state st;
    
    
    char t_996;
    char t_997;
    char t_998;
    Parrot_init_arg_nci(interp, &st, "III");
    t_996 = (char)GET_NCI_I(0);
    t_997 = (char)GET_NCI_I(1);
    t_998 = (char)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_996,t_997,t_998);
    
    
    
}
static void
pcf_v_cccc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char, char, char, char);
    func_t pointer;
    call_state st;
    
    
    char t_999;
    char t_1000;
    char t_1001;
    char t_1002;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_999 = (char)GET_NCI_I(0);
    t_1000 = (char)GET_NCI_I(1);
    t_1001 = (char)GET_NCI_I(2);
    t_1002 = (char)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_999,t_1000,t_1001,t_1002);
    
    
    
}
static void
pcf_v_ccccff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char, char, char, char, float, float);
    func_t pointer;
    call_state st;
    
    
    char t_1003;
    char t_1004;
    char t_1005;
    char t_1006;
    float t_1007;
    float t_1008;
    Parrot_init_arg_nci(interp, &st, "IIIINN");
    t_1003 = (char)GET_NCI_I(0);
    t_1004 = (char)GET_NCI_I(1);
    t_1005 = (char)GET_NCI_I(2);
    t_1006 = (char)GET_NCI_I(3);
    t_1007 = (float)GET_NCI_N(4);
    t_1008 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1003,t_1004,t_1005,t_1006,t_1007,t_1008);
    
    
    
}
static void
pcf_v_ccccfff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char, char, char, char, float, float, float);
    func_t pointer;
    call_state st;
    
    
    char t_1009;
    char t_1010;
    char t_1011;
    char t_1012;
    float t_1013;
    float t_1014;
    float t_1015;
    Parrot_init_arg_nci(interp, &st, "IIIINNN");
    t_1009 = (char)GET_NCI_I(0);
    t_1010 = (char)GET_NCI_I(1);
    t_1011 = (char)GET_NCI_I(2);
    t_1012 = (char)GET_NCI_I(3);
    t_1013 = (float)GET_NCI_N(4);
    t_1014 = (float)GET_NCI_N(5);
    t_1015 = (float)GET_NCI_N(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1009,t_1010,t_1011,t_1012,t_1013,t_1014,t_1015);
    
    
    
}
static void
pcf_v_d(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double);
    func_t pointer;
    call_state st;
    
    
    double t_1016;
    Parrot_init_arg_nci(interp, &st, "N");
    t_1016 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1016);
    
    
    
}
static void
pcf_v_dd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double);
    func_t pointer;
    call_state st;
    
    
    double t_1017;
    double t_1018;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_1017 = (double)GET_NCI_N(0);
    t_1018 = (double)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1017,t_1018);
    
    
    
}
static void
pcf_v_ddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, double);
    func_t pointer;
    call_state st;
    
    
    double t_1019;
    double t_1020;
    double t_1021;
    Parrot_init_arg_nci(interp, &st, "NNN");
    t_1019 = (double)GET_NCI_N(0);
    t_1020 = (double)GET_NCI_N(1);
    t_1021 = (double)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1019,t_1020,t_1021);
    
    
    
}
static void
pcf_v_dddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    double t_1022;
    double t_1023;
    double t_1024;
    double t_1025;
    Parrot_init_arg_nci(interp, &st, "NNNN");
    t_1022 = (double)GET_NCI_N(0);
    t_1023 = (double)GET_NCI_N(1);
    t_1024 = (double)GET_NCI_N(2);
    t_1025 = (double)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1022,t_1023,t_1024,t_1025);
    
    
    
}
static void
pcf_v_dddddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    double t_1026;
    double t_1027;
    double t_1028;
    double t_1029;
    double t_1030;
    double t_1031;
    Parrot_init_arg_nci(interp, &st, "NNNNNN");
    t_1026 = (double)GET_NCI_N(0);
    t_1027 = (double)GET_NCI_N(1);
    t_1028 = (double)GET_NCI_N(2);
    t_1029 = (double)GET_NCI_N(3);
    t_1030 = (double)GET_NCI_N(4);
    t_1031 = (double)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1026,t_1027,t_1028,t_1029,t_1030,t_1031);
    
    
    
}
static void
pcf_v_ddddddddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, double, double, double, double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    double t_1032;
    double t_1033;
    double t_1034;
    double t_1035;
    double t_1036;
    double t_1037;
    double t_1038;
    double t_1039;
    double t_1040;
    Parrot_init_arg_nci(interp, &st, "NNNNNNNNN");
    t_1032 = (double)GET_NCI_N(0);
    t_1033 = (double)GET_NCI_N(1);
    t_1034 = (double)GET_NCI_N(2);
    t_1035 = (double)GET_NCI_N(3);
    t_1036 = (double)GET_NCI_N(4);
    t_1037 = (double)GET_NCI_N(5);
    t_1038 = (double)GET_NCI_N(6);
    t_1039 = (double)GET_NCI_N(7);
    t_1040 = (double)GET_NCI_N(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1032,t_1033,t_1034,t_1035,t_1036,t_1037,t_1038,t_1039,t_1040);
    
    
    
}
static void
pcf_v_ddddp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, double, double, void *);
    func_t pointer;
    call_state st;
    
    
    double t_1041;
    double t_1042;
    double t_1043;
    double t_1044;
    PMC *t_1045;
    Parrot_init_arg_nci(interp, &st, "NNNNP");
    t_1041 = (double)GET_NCI_N(0);
    t_1042 = (double)GET_NCI_N(1);
    t_1043 = (double)GET_NCI_N(2);
    t_1044 = (double)GET_NCI_N(3);
    t_1045 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1041,t_1042,t_1043,t_1044,PMC_data(t_1045));
    
    
    
}
static void
pcf_v_ddii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, double, int, int);
    func_t pointer;
    call_state st;
    
    
    double t_1046;
    double t_1047;
    int t_1048;
    int t_1049;
    Parrot_init_arg_nci(interp, &st, "NNII");
    t_1046 = (double)GET_NCI_N(0);
    t_1047 = (double)GET_NCI_N(1);
    t_1048 = (int)GET_NCI_I(2);
    t_1049 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1046,t_1047,t_1048,t_1049);
    
    
    
}
static void
pcf_v_dii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(double, int, int);
    func_t pointer;
    call_state st;
    
    
    double t_1050;
    int t_1051;
    int t_1052;
    Parrot_init_arg_nci(interp, &st, "NII");
    t_1050 = (double)GET_NCI_N(0);
    t_1051 = (int)GET_NCI_I(1);
    t_1052 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1050,t_1051,t_1052);
    
    
    
}
static void
pcf_v_f(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float);
    func_t pointer;
    call_state st;
    
    
    float t_1053;
    Parrot_init_arg_nci(interp, &st, "N");
    t_1053 = (float)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1053);
    
    
    
}
static void
pcf_v_fc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, char);
    func_t pointer;
    call_state st;
    
    
    float t_1054;
    char t_1055;
    Parrot_init_arg_nci(interp, &st, "NI");
    t_1054 = (float)GET_NCI_N(0);
    t_1055 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1054,t_1055);
    
    
    
}
static void
pcf_v_ff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1056;
    float t_1057;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_1056 = (float)GET_NCI_N(0);
    t_1057 = (float)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1056,t_1057);
    
    
    
}
static void
pcf_v_ffccccfff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, char, char, char, char, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1058;
    float t_1059;
    char t_1060;
    char t_1061;
    char t_1062;
    char t_1063;
    float t_1064;
    float t_1065;
    float t_1066;
    Parrot_init_arg_nci(interp, &st, "NNIIIINNN");
    t_1058 = (float)GET_NCI_N(0);
    t_1059 = (float)GET_NCI_N(1);
    t_1060 = (char)GET_NCI_I(2);
    t_1061 = (char)GET_NCI_I(3);
    t_1062 = (char)GET_NCI_I(4);
    t_1063 = (char)GET_NCI_I(5);
    t_1064 = (float)GET_NCI_N(6);
    t_1065 = (float)GET_NCI_N(7);
    t_1066 = (float)GET_NCI_N(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1058,t_1059,t_1060,t_1061,t_1062,t_1063,t_1064,t_1065,t_1066);
    
    
    
}
static void
pcf_v_fff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1067;
    float t_1068;
    float t_1069;
    Parrot_init_arg_nci(interp, &st, "NNN");
    t_1067 = (float)GET_NCI_N(0);
    t_1068 = (float)GET_NCI_N(1);
    t_1069 = (float)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1067,t_1068,t_1069);
    
    
    
}
static void
pcf_v_ffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1070;
    float t_1071;
    float t_1072;
    float t_1073;
    Parrot_init_arg_nci(interp, &st, "NNNN");
    t_1070 = (float)GET_NCI_N(0);
    t_1071 = (float)GET_NCI_N(1);
    t_1072 = (float)GET_NCI_N(2);
    t_1073 = (float)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1070,t_1071,t_1072,t_1073);
    
    
    
}
static void
pcf_v_fffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1074;
    float t_1075;
    float t_1076;
    float t_1077;
    float t_1078;
    Parrot_init_arg_nci(interp, &st, "NNNNN");
    t_1074 = (float)GET_NCI_N(0);
    t_1075 = (float)GET_NCI_N(1);
    t_1076 = (float)GET_NCI_N(2);
    t_1077 = (float)GET_NCI_N(3);
    t_1078 = (float)GET_NCI_N(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1074,t_1075,t_1076,t_1077,t_1078);
    
    
    
}
static void
pcf_v_ffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1079;
    float t_1080;
    float t_1081;
    float t_1082;
    float t_1083;
    float t_1084;
    Parrot_init_arg_nci(interp, &st, "NNNNNN");
    t_1079 = (float)GET_NCI_N(0);
    t_1080 = (float)GET_NCI_N(1);
    t_1081 = (float)GET_NCI_N(2);
    t_1082 = (float)GET_NCI_N(3);
    t_1083 = (float)GET_NCI_N(4);
    t_1084 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1079,t_1080,t_1081,t_1082,t_1083,t_1084);
    
    
    
}
static void
pcf_v_ffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1085;
    float t_1086;
    float t_1087;
    float t_1088;
    float t_1089;
    float t_1090;
    float t_1091;
    float t_1092;
    Parrot_init_arg_nci(interp, &st, "NNNNNNNN");
    t_1085 = (float)GET_NCI_N(0);
    t_1086 = (float)GET_NCI_N(1);
    t_1087 = (float)GET_NCI_N(2);
    t_1088 = (float)GET_NCI_N(3);
    t_1089 = (float)GET_NCI_N(4);
    t_1090 = (float)GET_NCI_N(5);
    t_1091 = (float)GET_NCI_N(6);
    t_1092 = (float)GET_NCI_N(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1085,t_1086,t_1087,t_1088,t_1089,t_1090,t_1091,t_1092);
    
    
    
}
static void
pcf_v_ffffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1093;
    float t_1094;
    float t_1095;
    float t_1096;
    float t_1097;
    float t_1098;
    float t_1099;
    float t_1100;
    float t_1101;
    float t_1102;
    Parrot_init_arg_nci(interp, &st, "NNNNNNNNNN");
    t_1093 = (float)GET_NCI_N(0);
    t_1094 = (float)GET_NCI_N(1);
    t_1095 = (float)GET_NCI_N(2);
    t_1096 = (float)GET_NCI_N(3);
    t_1097 = (float)GET_NCI_N(4);
    t_1098 = (float)GET_NCI_N(5);
    t_1099 = (float)GET_NCI_N(6);
    t_1100 = (float)GET_NCI_N(7);
    t_1101 = (float)GET_NCI_N(8);
    t_1102 = (float)GET_NCI_N(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1093,t_1094,t_1095,t_1096,t_1097,t_1098,t_1099,t_1100,t_1101,t_1102);
    
    
    
}
static void
pcf_v_ffffffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1103;
    float t_1104;
    float t_1105;
    float t_1106;
    float t_1107;
    float t_1108;
    float t_1109;
    float t_1110;
    float t_1111;
    float t_1112;
    float t_1113;
    float t_1114;
    Parrot_init_arg_nci(interp, &st, "NNNNNNNNNNNN");
    t_1103 = (float)GET_NCI_N(0);
    t_1104 = (float)GET_NCI_N(1);
    t_1105 = (float)GET_NCI_N(2);
    t_1106 = (float)GET_NCI_N(3);
    t_1107 = (float)GET_NCI_N(4);
    t_1108 = (float)GET_NCI_N(5);
    t_1109 = (float)GET_NCI_N(6);
    t_1110 = (float)GET_NCI_N(7);
    t_1111 = (float)GET_NCI_N(8);
    t_1112 = (float)GET_NCI_N(9);
    t_1113 = (float)GET_NCI_N(10);
    t_1114 = (float)GET_NCI_N(11);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1103,t_1104,t_1105,t_1106,t_1107,t_1108,t_1109,t_1110,t_1111,t_1112,t_1113,t_1114);
    
    
    
}
static void
pcf_v_fffffffffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float, float, float, float, float, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    float t_1115;
    float t_1116;
    float t_1117;
    float t_1118;
    float t_1119;
    float t_1120;
    float t_1121;
    float t_1122;
    float t_1123;
    float t_1124;
    float t_1125;
    float t_1126;
    float t_1127;
    float t_1128;
    float t_1129;
    Parrot_init_arg_nci(interp, &st, "NNNNNNNNNNNNNNN");
    t_1115 = (float)GET_NCI_N(0);
    t_1116 = (float)GET_NCI_N(1);
    t_1117 = (float)GET_NCI_N(2);
    t_1118 = (float)GET_NCI_N(3);
    t_1119 = (float)GET_NCI_N(4);
    t_1120 = (float)GET_NCI_N(5);
    t_1121 = (float)GET_NCI_N(6);
    t_1122 = (float)GET_NCI_N(7);
    t_1123 = (float)GET_NCI_N(8);
    t_1124 = (float)GET_NCI_N(9);
    t_1125 = (float)GET_NCI_N(10);
    t_1126 = (float)GET_NCI_N(11);
    t_1127 = (float)GET_NCI_N(12);
    t_1128 = (float)GET_NCI_N(13);
    t_1129 = (float)GET_NCI_N(14);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1115,t_1116,t_1117,t_1118,t_1119,t_1120,t_1121,t_1122,t_1123,t_1124,t_1125,t_1126,t_1127,t_1128,t_1129);
    
    
    
}
static void
pcf_v_iccc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char, char, char);
    func_t pointer;
    call_state st;
    
    
    int t_1130;
    char t_1131;
    char t_1132;
    char t_1133;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1130 = (int)GET_NCI_I(0);
    t_1131 = (char)GET_NCI_I(1);
    t_1132 = (char)GET_NCI_I(2);
    t_1133 = (char)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1130,t_1131,t_1132,t_1133);
    
    
    
}
static void
pcf_v_icccc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char, char, char, char);
    func_t pointer;
    call_state st;
    
    
    int t_1134;
    char t_1135;
    char t_1136;
    char t_1137;
    char t_1138;
    Parrot_init_arg_nci(interp, &st, "IIIII");
    t_1134 = (int)GET_NCI_I(0);
    t_1135 = (char)GET_NCI_I(1);
    t_1136 = (char)GET_NCI_I(2);
    t_1137 = (char)GET_NCI_I(3);
    t_1138 = (char)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1134,t_1135,t_1136,t_1137,t_1138);
    
    
    
}
static void
pcf_v_iccccfff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char, char, char, char, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1139;
    char t_1140;
    char t_1141;
    char t_1142;
    char t_1143;
    float t_1144;
    float t_1145;
    float t_1146;
    Parrot_init_arg_nci(interp, &st, "IIIIINNN");
    t_1139 = (int)GET_NCI_I(0);
    t_1140 = (char)GET_NCI_I(1);
    t_1141 = (char)GET_NCI_I(2);
    t_1142 = (char)GET_NCI_I(3);
    t_1143 = (char)GET_NCI_I(4);
    t_1144 = (float)GET_NCI_N(5);
    t_1145 = (float)GET_NCI_N(6);
    t_1146 = (float)GET_NCI_N(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1139,t_1140,t_1141,t_1142,t_1143,t_1144,t_1145,t_1146);
    
    
    
}
static void
pcf_v_iciip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1147;
    char t_1148;
    int t_1149;
    int t_1150;
    PMC *t_1151;
    Parrot_init_arg_nci(interp, &st, "IIIIP");
    t_1147 = (int)GET_NCI_I(0);
    t_1148 = (char)GET_NCI_I(1);
    t_1149 = (int)GET_NCI_I(2);
    t_1150 = (int)GET_NCI_I(3);
    t_1151 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1147,t_1148,t_1149,t_1150,PMC_data(t_1151));
    
    
    
}
static void
pcf_v_id(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double);
    func_t pointer;
    call_state st;
    
    
    int t_1152;
    double t_1153;
    Parrot_init_arg_nci(interp, &st, "IN");
    t_1152 = (int)GET_NCI_I(0);
    t_1153 = (double)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1152,t_1153);
    
    
    
}
static void
pcf_v_idd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1154;
    double t_1155;
    double t_1156;
    Parrot_init_arg_nci(interp, &st, "INN");
    t_1154 = (int)GET_NCI_I(0);
    t_1155 = (double)GET_NCI_N(1);
    t_1156 = (double)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1154,t_1155,t_1156);
    
    
    
}
static void
pcf_v_iddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1157;
    double t_1158;
    double t_1159;
    double t_1160;
    Parrot_init_arg_nci(interp, &st, "INNN");
    t_1157 = (int)GET_NCI_I(0);
    t_1158 = (double)GET_NCI_N(1);
    t_1159 = (double)GET_NCI_N(2);
    t_1160 = (double)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1157,t_1158,t_1159,t_1160);
    
    
    
}
static void
pcf_v_idddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1161;
    double t_1162;
    double t_1163;
    double t_1164;
    double t_1165;
    Parrot_init_arg_nci(interp, &st, "INNNN");
    t_1161 = (int)GET_NCI_I(0);
    t_1162 = (double)GET_NCI_N(1);
    t_1163 = (double)GET_NCI_N(2);
    t_1164 = (double)GET_NCI_N(3);
    t_1165 = (double)GET_NCI_N(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1161,t_1162,t_1163,t_1164,t_1165);
    
    
    
}
static void
pcf_v_iddidd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, int, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1166;
    double t_1167;
    double t_1168;
    int t_1169;
    double t_1170;
    double t_1171;
    Parrot_init_arg_nci(interp, &st, "INNINN");
    t_1166 = (int)GET_NCI_I(0);
    t_1167 = (double)GET_NCI_N(1);
    t_1168 = (double)GET_NCI_N(2);
    t_1169 = (int)GET_NCI_I(3);
    t_1170 = (double)GET_NCI_N(4);
    t_1171 = (double)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1166,t_1167,t_1168,t_1169,t_1170,t_1171);
    
    
    
}
static void
pcf_v_iddiiddiiddiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, int, int, double, double, int, int, double, double, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1172;
    double t_1173;
    double t_1174;
    int t_1175;
    int t_1176;
    double t_1177;
    double t_1178;
    int t_1179;
    int t_1180;
    double t_1181;
    double t_1182;
    int t_1183;
    int t_1184;
    PMC *t_1185;
    Parrot_init_arg_nci(interp, &st, "INNIINNIINNIIP");
    t_1172 = (int)GET_NCI_I(0);
    t_1173 = (double)GET_NCI_N(1);
    t_1174 = (double)GET_NCI_N(2);
    t_1175 = (int)GET_NCI_I(3);
    t_1176 = (int)GET_NCI_I(4);
    t_1177 = (double)GET_NCI_N(5);
    t_1178 = (double)GET_NCI_N(6);
    t_1179 = (int)GET_NCI_I(7);
    t_1180 = (int)GET_NCI_I(8);
    t_1181 = (double)GET_NCI_N(9);
    t_1182 = (double)GET_NCI_N(10);
    t_1183 = (int)GET_NCI_I(11);
    t_1184 = (int)GET_NCI_I(12);
    t_1185 = GET_NCI_P(13);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1172,t_1173,t_1174,t_1175,t_1176,t_1177,t_1178,t_1179,t_1180,t_1181,t_1182,t_1183,t_1184,PMC_data(t_1185));
    
    
    
}
static void
pcf_v_iddiiddiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, int, int, double, double, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1186;
    double t_1187;
    double t_1188;
    int t_1189;
    int t_1190;
    double t_1191;
    double t_1192;
    int t_1193;
    int t_1194;
    PMC *t_1195;
    Parrot_init_arg_nci(interp, &st, "INNIINNIIP");
    t_1186 = (int)GET_NCI_I(0);
    t_1187 = (double)GET_NCI_N(1);
    t_1188 = (double)GET_NCI_N(2);
    t_1189 = (int)GET_NCI_I(3);
    t_1190 = (int)GET_NCI_I(4);
    t_1191 = (double)GET_NCI_N(5);
    t_1192 = (double)GET_NCI_N(6);
    t_1193 = (int)GET_NCI_I(7);
    t_1194 = (int)GET_NCI_I(8);
    t_1195 = GET_NCI_P(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1186,t_1187,t_1188,t_1189,t_1190,t_1191,t_1192,t_1193,t_1194,PMC_data(t_1195));
    
    
    
}
static void
pcf_v_iddiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, double, double, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1196;
    double t_1197;
    double t_1198;
    int t_1199;
    int t_1200;
    PMC *t_1201;
    Parrot_init_arg_nci(interp, &st, "INNIIP");
    t_1196 = (int)GET_NCI_I(0);
    t_1197 = (double)GET_NCI_N(1);
    t_1198 = (double)GET_NCI_N(2);
    t_1199 = (int)GET_NCI_I(3);
    t_1200 = (int)GET_NCI_I(4);
    t_1201 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1196,t_1197,t_1198,t_1199,t_1200,PMC_data(t_1201));
    
    
    
}
static void
pcf_v_if(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float);
    func_t pointer;
    call_state st;
    
    
    int t_1202;
    float t_1203;
    Parrot_init_arg_nci(interp, &st, "IN");
    t_1202 = (int)GET_NCI_I(0);
    t_1203 = (float)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1202,t_1203);
    
    
    
}
static void
pcf_v_iff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1204;
    float t_1205;
    float t_1206;
    Parrot_init_arg_nci(interp, &st, "INN");
    t_1204 = (int)GET_NCI_I(0);
    t_1205 = (float)GET_NCI_N(1);
    t_1206 = (float)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1204,t_1205,t_1206);
    
    
    
}
static void
pcf_v_ifff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1207;
    float t_1208;
    float t_1209;
    float t_1210;
    Parrot_init_arg_nci(interp, &st, "INNN");
    t_1207 = (int)GET_NCI_I(0);
    t_1208 = (float)GET_NCI_N(1);
    t_1209 = (float)GET_NCI_N(2);
    t_1210 = (float)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1207,t_1208,t_1209,t_1210);
    
    
    
}
static void
pcf_v_iffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1211;
    float t_1212;
    float t_1213;
    float t_1214;
    float t_1215;
    Parrot_init_arg_nci(interp, &st, "INNNN");
    t_1211 = (int)GET_NCI_I(0);
    t_1212 = (float)GET_NCI_N(1);
    t_1213 = (float)GET_NCI_N(2);
    t_1214 = (float)GET_NCI_N(3);
    t_1215 = (float)GET_NCI_N(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1211,t_1212,t_1213,t_1214,t_1215);
    
    
    
}
static void
pcf_v_ifffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1216;
    float t_1217;
    float t_1218;
    float t_1219;
    float t_1220;
    float t_1221;
    Parrot_init_arg_nci(interp, &st, "INNNNN");
    t_1216 = (int)GET_NCI_I(0);
    t_1217 = (float)GET_NCI_N(1);
    t_1218 = (float)GET_NCI_N(2);
    t_1219 = (float)GET_NCI_N(3);
    t_1220 = (float)GET_NCI_N(4);
    t_1221 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1216,t_1217,t_1218,t_1219,t_1220,t_1221);
    
    
    
}
static void
pcf_v_iffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1222;
    float t_1223;
    float t_1224;
    float t_1225;
    float t_1226;
    float t_1227;
    float t_1228;
    Parrot_init_arg_nci(interp, &st, "INNNNNN");
    t_1222 = (int)GET_NCI_I(0);
    t_1223 = (float)GET_NCI_N(1);
    t_1224 = (float)GET_NCI_N(2);
    t_1225 = (float)GET_NCI_N(3);
    t_1226 = (float)GET_NCI_N(4);
    t_1227 = (float)GET_NCI_N(5);
    t_1228 = (float)GET_NCI_N(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1222,t_1223,t_1224,t_1225,t_1226,t_1227,t_1228);
    
    
    
}
static void
pcf_v_iffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1229;
    float t_1230;
    float t_1231;
    float t_1232;
    float t_1233;
    float t_1234;
    float t_1235;
    float t_1236;
    float t_1237;
    Parrot_init_arg_nci(interp, &st, "INNNNNNNN");
    t_1229 = (int)GET_NCI_I(0);
    t_1230 = (float)GET_NCI_N(1);
    t_1231 = (float)GET_NCI_N(2);
    t_1232 = (float)GET_NCI_N(3);
    t_1233 = (float)GET_NCI_N(4);
    t_1234 = (float)GET_NCI_N(5);
    t_1235 = (float)GET_NCI_N(6);
    t_1236 = (float)GET_NCI_N(7);
    t_1237 = (float)GET_NCI_N(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1229,t_1230,t_1231,t_1232,t_1233,t_1234,t_1235,t_1236,t_1237);
    
    
    
}
static void
pcf_v_iffffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1238;
    float t_1239;
    float t_1240;
    float t_1241;
    float t_1242;
    float t_1243;
    float t_1244;
    float t_1245;
    float t_1246;
    float t_1247;
    float t_1248;
    Parrot_init_arg_nci(interp, &st, "INNNNNNNNNN");
    t_1238 = (int)GET_NCI_I(0);
    t_1239 = (float)GET_NCI_N(1);
    t_1240 = (float)GET_NCI_N(2);
    t_1241 = (float)GET_NCI_N(3);
    t_1242 = (float)GET_NCI_N(4);
    t_1243 = (float)GET_NCI_N(5);
    t_1244 = (float)GET_NCI_N(6);
    t_1245 = (float)GET_NCI_N(7);
    t_1246 = (float)GET_NCI_N(8);
    t_1247 = (float)GET_NCI_N(9);
    t_1248 = (float)GET_NCI_N(10);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1238,t_1239,t_1240,t_1241,t_1242,t_1243,t_1244,t_1245,t_1246,t_1247,t_1248);
    
    
    
}
static void
pcf_v_iffffffffffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, float, float, float, float, float, float, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1249;
    float t_1250;
    float t_1251;
    float t_1252;
    float t_1253;
    float t_1254;
    float t_1255;
    float t_1256;
    float t_1257;
    float t_1258;
    float t_1259;
    float t_1260;
    float t_1261;
    Parrot_init_arg_nci(interp, &st, "INNNNNNNNNNNN");
    t_1249 = (int)GET_NCI_I(0);
    t_1250 = (float)GET_NCI_N(1);
    t_1251 = (float)GET_NCI_N(2);
    t_1252 = (float)GET_NCI_N(3);
    t_1253 = (float)GET_NCI_N(4);
    t_1254 = (float)GET_NCI_N(5);
    t_1255 = (float)GET_NCI_N(6);
    t_1256 = (float)GET_NCI_N(7);
    t_1257 = (float)GET_NCI_N(8);
    t_1258 = (float)GET_NCI_N(9);
    t_1259 = (float)GET_NCI_N(10);
    t_1260 = (float)GET_NCI_N(11);
    t_1261 = (float)GET_NCI_N(12);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1249,t_1250,t_1251,t_1252,t_1253,t_1254,t_1255,t_1256,t_1257,t_1258,t_1259,t_1260,t_1261);
    
    
    
}
static void
pcf_v_iffiff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, int, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1262;
    float t_1263;
    float t_1264;
    int t_1265;
    float t_1266;
    float t_1267;
    Parrot_init_arg_nci(interp, &st, "INNINN");
    t_1262 = (int)GET_NCI_I(0);
    t_1263 = (float)GET_NCI_N(1);
    t_1264 = (float)GET_NCI_N(2);
    t_1265 = (int)GET_NCI_I(3);
    t_1266 = (float)GET_NCI_N(4);
    t_1267 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1262,t_1263,t_1264,t_1265,t_1266,t_1267);
    
    
    
}
static void
pcf_v_iffiiffiiffiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, int, int, float, float, int, int, float, float, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1268;
    float t_1269;
    float t_1270;
    int t_1271;
    int t_1272;
    float t_1273;
    float t_1274;
    int t_1275;
    int t_1276;
    float t_1277;
    float t_1278;
    int t_1279;
    int t_1280;
    PMC *t_1281;
    Parrot_init_arg_nci(interp, &st, "INNIINNIINNIIP");
    t_1268 = (int)GET_NCI_I(0);
    t_1269 = (float)GET_NCI_N(1);
    t_1270 = (float)GET_NCI_N(2);
    t_1271 = (int)GET_NCI_I(3);
    t_1272 = (int)GET_NCI_I(4);
    t_1273 = (float)GET_NCI_N(5);
    t_1274 = (float)GET_NCI_N(6);
    t_1275 = (int)GET_NCI_I(7);
    t_1276 = (int)GET_NCI_I(8);
    t_1277 = (float)GET_NCI_N(9);
    t_1278 = (float)GET_NCI_N(10);
    t_1279 = (int)GET_NCI_I(11);
    t_1280 = (int)GET_NCI_I(12);
    t_1281 = GET_NCI_P(13);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1268,t_1269,t_1270,t_1271,t_1272,t_1273,t_1274,t_1275,t_1276,t_1277,t_1278,t_1279,t_1280,PMC_data(t_1281));
    
    
    
}
static void
pcf_v_iffiiffiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, int, int, float, float, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1282;
    float t_1283;
    float t_1284;
    int t_1285;
    int t_1286;
    float t_1287;
    float t_1288;
    int t_1289;
    int t_1290;
    PMC *t_1291;
    Parrot_init_arg_nci(interp, &st, "INNIINNIIP");
    t_1282 = (int)GET_NCI_I(0);
    t_1283 = (float)GET_NCI_N(1);
    t_1284 = (float)GET_NCI_N(2);
    t_1285 = (int)GET_NCI_I(3);
    t_1286 = (int)GET_NCI_I(4);
    t_1287 = (float)GET_NCI_N(5);
    t_1288 = (float)GET_NCI_N(6);
    t_1289 = (int)GET_NCI_I(7);
    t_1290 = (int)GET_NCI_I(8);
    t_1291 = GET_NCI_P(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1282,t_1283,t_1284,t_1285,t_1286,t_1287,t_1288,t_1289,t_1290,PMC_data(t_1291));
    
    
    
}
static void
pcf_v_iffiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, float, float, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1292;
    float t_1293;
    float t_1294;
    int t_1295;
    int t_1296;
    PMC *t_1297;
    Parrot_init_arg_nci(interp, &st, "INNIIP");
    t_1292 = (int)GET_NCI_I(0);
    t_1293 = (float)GET_NCI_N(1);
    t_1294 = (float)GET_NCI_N(2);
    t_1295 = (int)GET_NCI_I(3);
    t_1296 = (int)GET_NCI_I(4);
    t_1297 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1292,t_1293,t_1294,t_1295,t_1296,PMC_data(t_1297));
    
    
    
}
static void
pcf_v_iic(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char);
    func_t pointer;
    call_state st;
    
    
    int t_1298;
    int t_1299;
    char t_1300;
    Parrot_init_arg_nci(interp, &st, "III");
    t_1298 = (int)GET_NCI_I(0);
    t_1299 = (int)GET_NCI_I(1);
    t_1300 = (char)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1298,t_1299,t_1300);
    
    
    
}
static void
pcf_v_iicp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1301;
    int t_1302;
    char t_1303;
    PMC *t_1304;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_1301 = (int)GET_NCI_I(0);
    t_1302 = (int)GET_NCI_I(1);
    t_1303 = (char)GET_NCI_I(2);
    t_1304 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1301,t_1302,t_1303,PMC_data(t_1304));
    
    
    
}
static void
pcf_v_iid(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, double);
    func_t pointer;
    call_state st;
    
    
    int t_1305;
    int t_1306;
    double t_1307;
    Parrot_init_arg_nci(interp, &st, "IIN");
    t_1305 = (int)GET_NCI_I(0);
    t_1306 = (int)GET_NCI_I(1);
    t_1307 = (double)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1305,t_1306,t_1307);
    
    
    
}
static void
pcf_v_iidddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1308;
    int t_1309;
    double t_1310;
    double t_1311;
    double t_1312;
    double t_1313;
    Parrot_init_arg_nci(interp, &st, "IINNNN");
    t_1308 = (int)GET_NCI_I(0);
    t_1309 = (int)GET_NCI_I(1);
    t_1310 = (double)GET_NCI_N(2);
    t_1311 = (double)GET_NCI_N(3);
    t_1312 = (double)GET_NCI_N(4);
    t_1313 = (double)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1308,t_1309,t_1310,t_1311,t_1312,t_1313);
    
    
    
}
static void
pcf_v_iif(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, float);
    func_t pointer;
    call_state st;
    
    
    int t_1314;
    int t_1315;
    float t_1316;
    Parrot_init_arg_nci(interp, &st, "IIN");
    t_1314 = (int)GET_NCI_I(0);
    t_1315 = (int)GET_NCI_I(1);
    t_1316 = (float)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1314,t_1315,t_1316);
    
    
    
}
static void
pcf_v_iiffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1317;
    int t_1318;
    float t_1319;
    float t_1320;
    float t_1321;
    float t_1322;
    Parrot_init_arg_nci(interp, &st, "IINNNN");
    t_1317 = (int)GET_NCI_I(0);
    t_1318 = (int)GET_NCI_I(1);
    t_1319 = (float)GET_NCI_N(2);
    t_1320 = (float)GET_NCI_N(3);
    t_1321 = (float)GET_NCI_N(4);
    t_1322 = (float)GET_NCI_N(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1317,t_1318,t_1319,t_1320,t_1321,t_1322);
    
    
    
}
static void
pcf_v_iifffft(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, float, float, float, float, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1323;
    int t_1324;
    float t_1325;
    float t_1326;
    float t_1327;
    float t_1328;
    char *t_1329;
    Parrot_init_arg_nci(interp, &st, "IINNNNS");
    t_1323 = (int)GET_NCI_I(0);
    t_1324 = (int)GET_NCI_I(1);
    t_1325 = (float)GET_NCI_N(2);
    t_1326 = (float)GET_NCI_N(3);
    t_1327 = (float)GET_NCI_N(4);
    t_1328 = (float)GET_NCI_N(5);
    t_1329 = string_to_cstring(interp, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1323,t_1324,t_1325,t_1326,t_1327,t_1328,t_1329);
    
    
    string_cstring_free(t_1329);
}
static void
pcf_v_iii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1330;
    int t_1331;
    int t_1332;
    Parrot_init_arg_nci(interp, &st, "III");
    t_1330 = (int)GET_NCI_I(0);
    t_1331 = (int)GET_NCI_I(1);
    t_1332 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1330,t_1331,t_1332);
    
    
    
}
static void
pcf_v_iiic(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, char);
    func_t pointer;
    call_state st;
    
    
    int t_1333;
    int t_1334;
    int t_1335;
    char t_1336;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1333 = (int)GET_NCI_I(0);
    t_1334 = (int)GET_NCI_I(1);
    t_1335 = (int)GET_NCI_I(2);
    t_1336 = (char)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1333,t_1334,t_1335,t_1336);
    
    
    
}
static void
pcf_v_iiiciii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, char, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1337;
    int t_1338;
    int t_1339;
    char t_1340;
    int t_1341;
    int t_1342;
    int t_1343;
    Parrot_init_arg_nci(interp, &st, "IIIIIII");
    t_1337 = (int)GET_NCI_I(0);
    t_1338 = (int)GET_NCI_I(1);
    t_1339 = (int)GET_NCI_I(2);
    t_1340 = (char)GET_NCI_I(3);
    t_1341 = (int)GET_NCI_I(4);
    t_1342 = (int)GET_NCI_I(5);
    t_1343 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1337,t_1338,t_1339,t_1340,t_1341,t_1342,t_1343);
    
    
    
}
static void
pcf_v_iiicip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, char, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1344;
    int t_1345;
    int t_1346;
    char t_1347;
    int t_1348;
    PMC *t_1349;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_1344 = (int)GET_NCI_I(0);
    t_1345 = (int)GET_NCI_I(1);
    t_1346 = (int)GET_NCI_I(2);
    t_1347 = (char)GET_NCI_I(3);
    t_1348 = (int)GET_NCI_I(4);
    t_1349 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1344,t_1345,t_1346,t_1347,t_1348,PMC_data(t_1349));
    
    
    
}
static void
pcf_v_iiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1350;
    int t_1351;
    int t_1352;
    int t_1353;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1350 = (int)GET_NCI_I(0);
    t_1351 = (int)GET_NCI_I(1);
    t_1352 = (int)GET_NCI_I(2);
    t_1353 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1350,t_1351,t_1352,t_1353);
    
    
    
}
static void
pcf_v_iiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1354;
    int t_1355;
    int t_1356;
    int t_1357;
    int t_1358;
    Parrot_init_arg_nci(interp, &st, "IIIII");
    t_1354 = (int)GET_NCI_I(0);
    t_1355 = (int)GET_NCI_I(1);
    t_1356 = (int)GET_NCI_I(2);
    t_1357 = (int)GET_NCI_I(3);
    t_1358 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1354,t_1355,t_1356,t_1357,t_1358);
    
    
    
}
static void
pcf_v_iiiiicp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, char, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1359;
    int t_1360;
    int t_1361;
    int t_1362;
    int t_1363;
    char t_1364;
    PMC *t_1365;
    Parrot_init_arg_nci(interp, &st, "IIIIIIP");
    t_1359 = (int)GET_NCI_I(0);
    t_1360 = (int)GET_NCI_I(1);
    t_1361 = (int)GET_NCI_I(2);
    t_1362 = (int)GET_NCI_I(3);
    t_1363 = (int)GET_NCI_I(4);
    t_1364 = (char)GET_NCI_I(5);
    t_1365 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1359,t_1360,t_1361,t_1362,t_1363,t_1364,PMC_data(t_1365));
    
    
    
}
static void
pcf_v_iiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1366;
    int t_1367;
    int t_1368;
    int t_1369;
    int t_1370;
    int t_1371;
    Parrot_init_arg_nci(interp, &st, "IIIIII");
    t_1366 = (int)GET_NCI_I(0);
    t_1367 = (int)GET_NCI_I(1);
    t_1368 = (int)GET_NCI_I(2);
    t_1369 = (int)GET_NCI_I(3);
    t_1370 = (int)GET_NCI_I(4);
    t_1371 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1366,t_1367,t_1368,t_1369,t_1370,t_1371);
    
    
    
}
static void
pcf_v_iiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1372;
    int t_1373;
    int t_1374;
    int t_1375;
    int t_1376;
    int t_1377;
    int t_1378;
    Parrot_init_arg_nci(interp, &st, "IIIIIII");
    t_1372 = (int)GET_NCI_I(0);
    t_1373 = (int)GET_NCI_I(1);
    t_1374 = (int)GET_NCI_I(2);
    t_1375 = (int)GET_NCI_I(3);
    t_1376 = (int)GET_NCI_I(4);
    t_1377 = (int)GET_NCI_I(5);
    t_1378 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1372,t_1373,t_1374,t_1375,t_1376,t_1377,t_1378);
    
    
    
}
static void
pcf_v_iiiiiiiccc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, char, char, char);
    func_t pointer;
    call_state st;
    
    
    int t_1379;
    int t_1380;
    int t_1381;
    int t_1382;
    int t_1383;
    int t_1384;
    int t_1385;
    char t_1386;
    char t_1387;
    char t_1388;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIII");
    t_1379 = (int)GET_NCI_I(0);
    t_1380 = (int)GET_NCI_I(1);
    t_1381 = (int)GET_NCI_I(2);
    t_1382 = (int)GET_NCI_I(3);
    t_1383 = (int)GET_NCI_I(4);
    t_1384 = (int)GET_NCI_I(5);
    t_1385 = (int)GET_NCI_I(6);
    t_1386 = (char)GET_NCI_I(7);
    t_1387 = (char)GET_NCI_I(8);
    t_1388 = (char)GET_NCI_I(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1379,t_1380,t_1381,t_1382,t_1383,t_1384,t_1385,t_1386,t_1387,t_1388);
    
    
    
}
static void
pcf_v_iiiiiiicp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, char, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1389;
    int t_1390;
    int t_1391;
    int t_1392;
    int t_1393;
    int t_1394;
    int t_1395;
    char t_1396;
    PMC *t_1397;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIP");
    t_1389 = (int)GET_NCI_I(0);
    t_1390 = (int)GET_NCI_I(1);
    t_1391 = (int)GET_NCI_I(2);
    t_1392 = (int)GET_NCI_I(3);
    t_1393 = (int)GET_NCI_I(4);
    t_1394 = (int)GET_NCI_I(5);
    t_1395 = (int)GET_NCI_I(6);
    t_1396 = (char)GET_NCI_I(7);
    t_1397 = GET_NCI_P(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1389,t_1390,t_1391,t_1392,t_1393,t_1394,t_1395,t_1396,PMC_data(t_1397));
    
    
    
}
static void
pcf_v_iiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1398;
    int t_1399;
    int t_1400;
    int t_1401;
    int t_1402;
    int t_1403;
    int t_1404;
    int t_1405;
    Parrot_init_arg_nci(interp, &st, "IIIIIIII");
    t_1398 = (int)GET_NCI_I(0);
    t_1399 = (int)GET_NCI_I(1);
    t_1400 = (int)GET_NCI_I(2);
    t_1401 = (int)GET_NCI_I(3);
    t_1402 = (int)GET_NCI_I(4);
    t_1403 = (int)GET_NCI_I(5);
    t_1404 = (int)GET_NCI_I(6);
    t_1405 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1398,t_1399,t_1400,t_1401,t_1402,t_1403,t_1404,t_1405);
    
    
    
}
static void
pcf_v_iiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1406;
    int t_1407;
    int t_1408;
    int t_1409;
    int t_1410;
    int t_1411;
    int t_1412;
    int t_1413;
    int t_1414;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIII");
    t_1406 = (int)GET_NCI_I(0);
    t_1407 = (int)GET_NCI_I(1);
    t_1408 = (int)GET_NCI_I(2);
    t_1409 = (int)GET_NCI_I(3);
    t_1410 = (int)GET_NCI_I(4);
    t_1411 = (int)GET_NCI_I(5);
    t_1412 = (int)GET_NCI_I(6);
    t_1413 = (int)GET_NCI_I(7);
    t_1414 = (int)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1406,t_1407,t_1408,t_1409,t_1410,t_1411,t_1412,t_1413,t_1414);
    
    
    
}
static void
pcf_v_iiiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1415;
    int t_1416;
    int t_1417;
    int t_1418;
    int t_1419;
    int t_1420;
    int t_1421;
    int t_1422;
    int t_1423;
    int t_1424;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIII");
    t_1415 = (int)GET_NCI_I(0);
    t_1416 = (int)GET_NCI_I(1);
    t_1417 = (int)GET_NCI_I(2);
    t_1418 = (int)GET_NCI_I(3);
    t_1419 = (int)GET_NCI_I(4);
    t_1420 = (int)GET_NCI_I(5);
    t_1421 = (int)GET_NCI_I(6);
    t_1422 = (int)GET_NCI_I(7);
    t_1423 = (int)GET_NCI_I(8);
    t_1424 = (int)GET_NCI_I(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1415,t_1416,t_1417,t_1418,t_1419,t_1420,t_1421,t_1422,t_1423,t_1424);
    
    
    
}
static void
pcf_v_iiiiiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1425;
    int t_1426;
    int t_1427;
    int t_1428;
    int t_1429;
    int t_1430;
    int t_1431;
    int t_1432;
    int t_1433;
    int t_1434;
    int t_1435;
    int t_1436;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIIII");
    t_1425 = (int)GET_NCI_I(0);
    t_1426 = (int)GET_NCI_I(1);
    t_1427 = (int)GET_NCI_I(2);
    t_1428 = (int)GET_NCI_I(3);
    t_1429 = (int)GET_NCI_I(4);
    t_1430 = (int)GET_NCI_I(5);
    t_1431 = (int)GET_NCI_I(6);
    t_1432 = (int)GET_NCI_I(7);
    t_1433 = (int)GET_NCI_I(8);
    t_1434 = (int)GET_NCI_I(9);
    t_1435 = (int)GET_NCI_I(10);
    t_1436 = (int)GET_NCI_I(11);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1425,t_1426,t_1427,t_1428,t_1429,t_1430,t_1431,t_1432,t_1433,t_1434,t_1435,t_1436);
    
    
    
}
static void
pcf_v_iiiiiiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1437;
    int t_1438;
    int t_1439;
    int t_1440;
    int t_1441;
    int t_1442;
    int t_1443;
    int t_1444;
    int t_1445;
    int t_1446;
    int t_1447;
    int t_1448;
    int t_1449;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIIIII");
    t_1437 = (int)GET_NCI_I(0);
    t_1438 = (int)GET_NCI_I(1);
    t_1439 = (int)GET_NCI_I(2);
    t_1440 = (int)GET_NCI_I(3);
    t_1441 = (int)GET_NCI_I(4);
    t_1442 = (int)GET_NCI_I(5);
    t_1443 = (int)GET_NCI_I(6);
    t_1444 = (int)GET_NCI_I(7);
    t_1445 = (int)GET_NCI_I(8);
    t_1446 = (int)GET_NCI_I(9);
    t_1447 = (int)GET_NCI_I(10);
    t_1448 = (int)GET_NCI_I(11);
    t_1449 = (int)GET_NCI_I(12);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1437,t_1438,t_1439,t_1440,t_1441,t_1442,t_1443,t_1444,t_1445,t_1446,t_1447,t_1448,t_1449);
    
    
    
}
static void
pcf_v_iiiiiiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1450;
    int t_1451;
    int t_1452;
    int t_1453;
    int t_1454;
    int t_1455;
    int t_1456;
    int t_1457;
    int t_1458;
    int t_1459;
    int t_1460;
    int t_1461;
    PMC *t_1462;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIIIIP");
    t_1450 = (int)GET_NCI_I(0);
    t_1451 = (int)GET_NCI_I(1);
    t_1452 = (int)GET_NCI_I(2);
    t_1453 = (int)GET_NCI_I(3);
    t_1454 = (int)GET_NCI_I(4);
    t_1455 = (int)GET_NCI_I(5);
    t_1456 = (int)GET_NCI_I(6);
    t_1457 = (int)GET_NCI_I(7);
    t_1458 = (int)GET_NCI_I(8);
    t_1459 = (int)GET_NCI_I(9);
    t_1460 = (int)GET_NCI_I(10);
    t_1461 = (int)GET_NCI_I(11);
    t_1462 = GET_NCI_P(12);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1450,t_1451,t_1452,t_1453,t_1454,t_1455,t_1456,t_1457,t_1458,t_1459,t_1460,t_1461,PMC_data(t_1462));
    
    
    
}
static void
pcf_v_iiiiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1463;
    int t_1464;
    int t_1465;
    int t_1466;
    int t_1467;
    int t_1468;
    int t_1469;
    int t_1470;
    int t_1471;
    int t_1472;
    PMC *t_1473;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIIP");
    t_1463 = (int)GET_NCI_I(0);
    t_1464 = (int)GET_NCI_I(1);
    t_1465 = (int)GET_NCI_I(2);
    t_1466 = (int)GET_NCI_I(3);
    t_1467 = (int)GET_NCI_I(4);
    t_1468 = (int)GET_NCI_I(5);
    t_1469 = (int)GET_NCI_I(6);
    t_1470 = (int)GET_NCI_I(7);
    t_1471 = (int)GET_NCI_I(8);
    t_1472 = (int)GET_NCI_I(9);
    t_1473 = GET_NCI_P(10);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1463,t_1464,t_1465,t_1466,t_1467,t_1468,t_1469,t_1470,t_1471,t_1472,PMC_data(t_1473));
    
    
    
}
static void
pcf_v_iiiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1474;
    int t_1475;
    int t_1476;
    int t_1477;
    int t_1478;
    int t_1479;
    int t_1480;
    int t_1481;
    int t_1482;
    PMC *t_1483;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIIP");
    t_1474 = (int)GET_NCI_I(0);
    t_1475 = (int)GET_NCI_I(1);
    t_1476 = (int)GET_NCI_I(2);
    t_1477 = (int)GET_NCI_I(3);
    t_1478 = (int)GET_NCI_I(4);
    t_1479 = (int)GET_NCI_I(5);
    t_1480 = (int)GET_NCI_I(6);
    t_1481 = (int)GET_NCI_I(7);
    t_1482 = (int)GET_NCI_I(8);
    t_1483 = GET_NCI_P(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1474,t_1475,t_1476,t_1477,t_1478,t_1479,t_1480,t_1481,t_1482,PMC_data(t_1483));
    
    
    
}
static void
pcf_v_iiiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1484;
    int t_1485;
    int t_1486;
    int t_1487;
    int t_1488;
    int t_1489;
    int t_1490;
    int t_1491;
    PMC *t_1492;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIIP");
    t_1484 = (int)GET_NCI_I(0);
    t_1485 = (int)GET_NCI_I(1);
    t_1486 = (int)GET_NCI_I(2);
    t_1487 = (int)GET_NCI_I(3);
    t_1488 = (int)GET_NCI_I(4);
    t_1489 = (int)GET_NCI_I(5);
    t_1490 = (int)GET_NCI_I(6);
    t_1491 = (int)GET_NCI_I(7);
    t_1492 = GET_NCI_P(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1484,t_1485,t_1486,t_1487,t_1488,t_1489,t_1490,t_1491,PMC_data(t_1492));
    
    
    
}
static void
pcf_v_iiiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1493;
    int t_1494;
    int t_1495;
    int t_1496;
    int t_1497;
    int t_1498;
    int t_1499;
    PMC *t_1500;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIP");
    t_1493 = (int)GET_NCI_I(0);
    t_1494 = (int)GET_NCI_I(1);
    t_1495 = (int)GET_NCI_I(2);
    t_1496 = (int)GET_NCI_I(3);
    t_1497 = (int)GET_NCI_I(4);
    t_1498 = (int)GET_NCI_I(5);
    t_1499 = (int)GET_NCI_I(6);
    t_1500 = GET_NCI_P(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1493,t_1494,t_1495,t_1496,t_1497,t_1498,t_1499,PMC_data(t_1500));
    
    
    
}
static void
pcf_v_iiiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1501;
    int t_1502;
    int t_1503;
    int t_1504;
    int t_1505;
    int t_1506;
    PMC *t_1507;
    Parrot_init_arg_nci(interp, &st, "IIIIIIP");
    t_1501 = (int)GET_NCI_I(0);
    t_1502 = (int)GET_NCI_I(1);
    t_1503 = (int)GET_NCI_I(2);
    t_1504 = (int)GET_NCI_I(3);
    t_1505 = (int)GET_NCI_I(4);
    t_1506 = (int)GET_NCI_I(5);
    t_1507 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1501,t_1502,t_1503,t_1504,t_1505,t_1506,PMC_data(t_1507));
    
    
    
}
static void
pcf_v_iiiiiipp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, int, void *, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1508;
    int t_1509;
    int t_1510;
    int t_1511;
    int t_1512;
    int t_1513;
    PMC *t_1514;
    PMC *t_1515;
    Parrot_init_arg_nci(interp, &st, "IIIIIIPP");
    t_1508 = (int)GET_NCI_I(0);
    t_1509 = (int)GET_NCI_I(1);
    t_1510 = (int)GET_NCI_I(2);
    t_1511 = (int)GET_NCI_I(3);
    t_1512 = (int)GET_NCI_I(4);
    t_1513 = (int)GET_NCI_I(5);
    t_1514 = GET_NCI_P(6);
    t_1515 = GET_NCI_P(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1508,t_1509,t_1510,t_1511,t_1512,t_1513,PMC_data(t_1514),PMC_data(t_1515));
    
    
    
}
static void
pcf_v_iiiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1516;
    int t_1517;
    int t_1518;
    int t_1519;
    int t_1520;
    PMC *t_1521;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_1516 = (int)GET_NCI_I(0);
    t_1517 = (int)GET_NCI_I(1);
    t_1518 = (int)GET_NCI_I(2);
    t_1519 = (int)GET_NCI_I(3);
    t_1520 = (int)GET_NCI_I(4);
    t_1521 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1516,t_1517,t_1518,t_1519,t_1520,PMC_data(t_1521));
    
    
    
}
static void
pcf_v_iiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1522;
    int t_1523;
    int t_1524;
    int t_1525;
    PMC *t_1526;
    Parrot_init_arg_nci(interp, &st, "IIIIP");
    t_1522 = (int)GET_NCI_I(0);
    t_1523 = (int)GET_NCI_I(1);
    t_1524 = (int)GET_NCI_I(2);
    t_1525 = (int)GET_NCI_I(3);
    t_1526 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1522,t_1523,t_1524,t_1525,PMC_data(t_1526));
    
    
    
}
static void
pcf_v_iiiipt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, int, void *, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1527;
    int t_1528;
    int t_1529;
    int t_1530;
    PMC *t_1531;
    char *t_1532;
    Parrot_init_arg_nci(interp, &st, "IIIIPS");
    t_1527 = (int)GET_NCI_I(0);
    t_1528 = (int)GET_NCI_I(1);
    t_1529 = (int)GET_NCI_I(2);
    t_1530 = (int)GET_NCI_I(3);
    t_1531 = GET_NCI_P(4);
    t_1532 = string_to_cstring(interp, GET_NCI_S(5));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1527,t_1528,t_1529,t_1530,PMC_data(t_1531),t_1532);
    
    
    string_cstring_free(t_1532);
}
static void
pcf_v_iiil(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, long);
    func_t pointer;
    call_state st;
    
    
    int t_1533;
    int t_1534;
    int t_1535;
    long t_1536;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1533 = (int)GET_NCI_I(0);
    t_1534 = (int)GET_NCI_I(1);
    t_1535 = (int)GET_NCI_I(2);
    t_1536 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1533,t_1534,t_1535,t_1536);
    
    
    
}
static void
pcf_v_iiill(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, long, long);
    func_t pointer;
    call_state st;
    
    
    int t_1537;
    int t_1538;
    int t_1539;
    long t_1540;
    long t_1541;
    Parrot_init_arg_nci(interp, &st, "IIIII");
    t_1537 = (int)GET_NCI_I(0);
    t_1538 = (int)GET_NCI_I(1);
    t_1539 = (int)GET_NCI_I(2);
    t_1540 = (long)GET_NCI_I(3);
    t_1541 = (long)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1537,t_1538,t_1539,t_1540,t_1541);
    
    
    
}
static void
pcf_v_iiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1542;
    int t_1543;
    int t_1544;
    PMC *t_1545;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_1542 = (int)GET_NCI_I(0);
    t_1543 = (int)GET_NCI_I(1);
    t_1544 = (int)GET_NCI_I(2);
    t_1545 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1542,t_1543,t_1544,PMC_data(t_1545));
    
    
    
}
static void
pcf_v_iiipi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1546;
    int t_1547;
    int t_1548;
    PMC *t_1549;
    int t_1550;
    Parrot_init_arg_nci(interp, &st, "IIIPI");
    t_1546 = (int)GET_NCI_I(0);
    t_1547 = (int)GET_NCI_I(1);
    t_1548 = (int)GET_NCI_I(2);
    t_1549 = GET_NCI_P(3);
    t_1550 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1546,t_1547,t_1548,PMC_data(t_1549),t_1550);
    
    
    
}
static void
pcf_v_iiippi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, void *, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1551;
    int t_1552;
    int t_1553;
    PMC *t_1554;
    PMC *t_1555;
    int t_1556;
    Parrot_init_arg_nci(interp, &st, "IIIPPI");
    t_1551 = (int)GET_NCI_I(0);
    t_1552 = (int)GET_NCI_I(1);
    t_1553 = (int)GET_NCI_I(2);
    t_1554 = GET_NCI_P(3);
    t_1555 = GET_NCI_P(4);
    t_1556 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1551,t_1552,t_1553,PMC_data(t_1554),PMC_data(t_1555),t_1556);
    
    
    
}
static void
pcf_v_iiippp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, void *, void *, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1557;
    int t_1558;
    int t_1559;
    PMC *t_1560;
    PMC *t_1561;
    PMC *t_1562;
    Parrot_init_arg_nci(interp, &st, "IIIPPP");
    t_1557 = (int)GET_NCI_I(0);
    t_1558 = (int)GET_NCI_I(1);
    t_1559 = (int)GET_NCI_I(2);
    t_1560 = GET_NCI_P(3);
    t_1561 = GET_NCI_P(4);
    t_1562 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1557,t_1558,t_1559,PMC_data(t_1560),PMC_data(t_1561),PMC_data(t_1562));
    
    
    
}
static void
pcf_v_iiipppt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, void *, void *, void *, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1563;
    int t_1564;
    int t_1565;
    PMC *t_1566;
    PMC *t_1567;
    PMC *t_1568;
    char *t_1569;
    Parrot_init_arg_nci(interp, &st, "IIIPPPS");
    t_1563 = (int)GET_NCI_I(0);
    t_1564 = (int)GET_NCI_I(1);
    t_1565 = (int)GET_NCI_I(2);
    t_1566 = GET_NCI_P(3);
    t_1567 = GET_NCI_P(4);
    t_1568 = GET_NCI_P(5);
    t_1569 = string_to_cstring(interp, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1563,t_1564,t_1565,PMC_data(t_1566),PMC_data(t_1567),PMC_data(t_1568),t_1569);
    
    
    string_cstring_free(t_1569);
}
static void
pcf_v_iiit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, int, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1570;
    int t_1571;
    int t_1572;
    char *t_1573;
    Parrot_init_arg_nci(interp, &st, "IIIS");
    t_1570 = (int)GET_NCI_I(0);
    t_1571 = (int)GET_NCI_I(1);
    t_1572 = (int)GET_NCI_I(2);
    t_1573 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1570,t_1571,t_1572,t_1573);
    
    
    string_cstring_free(t_1573);
}
static void
pcf_v_iip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1574;
    int t_1575;
    PMC *t_1576;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_1574 = (int)GET_NCI_I(0);
    t_1575 = (int)GET_NCI_I(1);
    t_1576 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1574,t_1575,PMC_data(t_1576));
    
    
    
}
static void
pcf_v_iipi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1577;
    int t_1578;
    PMC *t_1579;
    int t_1580;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_1577 = (int)GET_NCI_I(0);
    t_1578 = (int)GET_NCI_I(1);
    t_1579 = GET_NCI_P(2);
    t_1580 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1577,t_1578,PMC_data(t_1579),t_1580);
    
    
    
}
static void
pcf_v_iipp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, void *, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1581;
    int t_1582;
    PMC *t_1583;
    PMC *t_1584;
    Parrot_init_arg_nci(interp, &st, "IIPP");
    t_1581 = (int)GET_NCI_I(0);
    t_1582 = (int)GET_NCI_I(1);
    t_1583 = GET_NCI_P(2);
    t_1584 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1581,t_1582,PMC_data(t_1583),PMC_data(t_1584));
    
    
    
}
static void
pcf_v_iipt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, void *, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1585;
    int t_1586;
    PMC *t_1587;
    char *t_1588;
    Parrot_init_arg_nci(interp, &st, "IIPS");
    t_1585 = (int)GET_NCI_I(0);
    t_1586 = (int)GET_NCI_I(1);
    t_1587 = GET_NCI_P(2);
    t_1588 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1585,t_1586,PMC_data(t_1587),t_1588);
    
    
    string_cstring_free(t_1588);
}
static void
pcf_v_iit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1589;
    int t_1590;
    char *t_1591;
    Parrot_init_arg_nci(interp, &st, "IIS");
    t_1589 = (int)GET_NCI_I(0);
    t_1590 = (int)GET_NCI_I(1);
    t_1591 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1589,t_1590,t_1591);
    
    
    string_cstring_free(t_1591);
}
static void
pcf_v_iitdddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char *, double, double, double, double);
    func_t pointer;
    call_state st;
    
    
    int t_1592;
    int t_1593;
    char *t_1594;
    double t_1595;
    double t_1596;
    double t_1597;
    double t_1598;
    Parrot_init_arg_nci(interp, &st, "IISNNNN");
    t_1592 = (int)GET_NCI_I(0);
    t_1593 = (int)GET_NCI_I(1);
    t_1594 = string_to_cstring(interp, GET_NCI_S(2));
    t_1595 = (double)GET_NCI_N(3);
    t_1596 = (double)GET_NCI_N(4);
    t_1597 = (double)GET_NCI_N(5);
    t_1598 = (double)GET_NCI_N(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1592,t_1593,t_1594,t_1595,t_1596,t_1597,t_1598);
    
    
    string_cstring_free(t_1594);
}
static void
pcf_v_iitffff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char *, float, float, float, float);
    func_t pointer;
    call_state st;
    
    
    int t_1599;
    int t_1600;
    char *t_1601;
    float t_1602;
    float t_1603;
    float t_1604;
    float t_1605;
    Parrot_init_arg_nci(interp, &st, "IISNNNN");
    t_1599 = (int)GET_NCI_I(0);
    t_1600 = (int)GET_NCI_I(1);
    t_1601 = string_to_cstring(interp, GET_NCI_S(2));
    t_1602 = (float)GET_NCI_N(3);
    t_1603 = (float)GET_NCI_N(4);
    t_1604 = (float)GET_NCI_N(5);
    t_1605 = (float)GET_NCI_N(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1599,t_1600,t_1601,t_1602,t_1603,t_1604,t_1605);
    
    
    string_cstring_free(t_1601);
}
static void
pcf_v_iitp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int, char *, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1606;
    int t_1607;
    char *t_1608;
    PMC *t_1609;
    Parrot_init_arg_nci(interp, &st, "IISP");
    t_1606 = (int)GET_NCI_I(0);
    t_1607 = (int)GET_NCI_I(1);
    t_1608 = string_to_cstring(interp, GET_NCI_S(2));
    t_1609 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1606,t_1607,t_1608,PMC_data(t_1609));
    
    
    string_cstring_free(t_1608);
}
static void
pcf_v_ill(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long);
    func_t pointer;
    call_state st;
    
    
    int t_1610;
    long t_1611;
    long t_1612;
    Parrot_init_arg_nci(interp, &st, "III");
    t_1610 = (int)GET_NCI_I(0);
    t_1611 = (long)GET_NCI_I(1);
    t_1612 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1610,t_1611,t_1612);
    
    
    
}
static void
pcf_v_illp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1613;
    long t_1614;
    long t_1615;
    PMC *t_1616;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_1613 = (int)GET_NCI_I(0);
    t_1614 = (long)GET_NCI_I(1);
    t_1615 = (long)GET_NCI_I(2);
    t_1616 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1613,t_1614,t_1615,PMC_data(t_1616));
    
    
    
}
static void
pcf_v_ilpi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1617;
    long t_1618;
    PMC *t_1619;
    int t_1620;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_1617 = (int)GET_NCI_I(0);
    t_1618 = (long)GET_NCI_I(1);
    t_1619 = GET_NCI_P(2);
    t_1620 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1617,t_1618,PMC_data(t_1619),t_1620);
    
    
    
}
static void
pcf_v_ip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1621;
    PMC *t_1622;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_1621 = (int)GET_NCI_I(0);
    t_1622 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1621,PMC_data(t_1622));
    
    
    
}
static void
pcf_v_ipi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1623;
    PMC *t_1624;
    int t_1625;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_1623 = (int)GET_NCI_I(0);
    t_1624 = GET_NCI_P(1);
    t_1625 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1623,PMC_data(t_1624),t_1625);
    
    
    
}
static void
pcf_v_ipipi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *, int, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1626;
    PMC *t_1627;
    int t_1628;
    PMC *t_1629;
    int t_1630;
    Parrot_init_arg_nci(interp, &st, "IPIPI");
    t_1626 = (int)GET_NCI_I(0);
    t_1627 = GET_NCI_P(1);
    t_1628 = (int)GET_NCI_I(2);
    t_1629 = GET_NCI_P(3);
    t_1630 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1626,PMC_data(t_1627),t_1628,PMC_data(t_1629),t_1630);
    
    
    
}
static void
pcf_v_ipp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *, void *);
    func_t pointer;
    call_state st;
    
    
    int t_1631;
    PMC *t_1632;
    PMC *t_1633;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_1631 = (int)GET_NCI_I(0);
    t_1632 = GET_NCI_P(1);
    t_1633 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1631,PMC_data(t_1632),PMC_data(t_1633));
    
    
    
}
static void
pcf_v_ippi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *, void *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1634;
    PMC *t_1635;
    PMC *t_1636;
    int t_1637;
    Parrot_init_arg_nci(interp, &st, "IPPI");
    t_1634 = (int)GET_NCI_I(0);
    t_1635 = GET_NCI_P(1);
    t_1636 = GET_NCI_P(2);
    t_1637 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1634,PMC_data(t_1635),PMC_data(t_1636),t_1637);
    
    
    
}
static void
pcf_v_ippii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, void *, void *, int, int);
    func_t pointer;
    call_state st;
    
    
    int t_1638;
    PMC *t_1639;
    PMC *t_1640;
    int t_1641;
    int t_1642;
    Parrot_init_arg_nci(interp, &st, "IPPII");
    t_1638 = (int)GET_NCI_I(0);
    t_1639 = GET_NCI_P(1);
    t_1640 = GET_NCI_P(2);
    t_1641 = (int)GET_NCI_I(3);
    t_1642 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1638,PMC_data(t_1639),PMC_data(t_1640),t_1641,t_1642);
    
    
    
}
static void
pcf_v_is(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, short);
    func_t pointer;
    call_state st;
    
    
    int t_1643;
    short t_1644;
    Parrot_init_arg_nci(interp, &st, "II");
    t_1643 = (int)GET_NCI_I(0);
    t_1644 = (short)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1643,t_1644);
    
    
    
}
static void
pcf_v_iss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, short, short);
    func_t pointer;
    call_state st;
    
    
    int t_1645;
    short t_1646;
    short t_1647;
    Parrot_init_arg_nci(interp, &st, "III");
    t_1645 = (int)GET_NCI_I(0);
    t_1646 = (short)GET_NCI_I(1);
    t_1647 = (short)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1645,t_1646,t_1647);
    
    
    
}
static void
pcf_v_isss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, short, short, short);
    func_t pointer;
    call_state st;
    
    
    int t_1648;
    short t_1649;
    short t_1650;
    short t_1651;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1648 = (int)GET_NCI_I(0);
    t_1649 = (short)GET_NCI_I(1);
    t_1650 = (short)GET_NCI_I(2);
    t_1651 = (short)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1648,t_1649,t_1650,t_1651);
    
    
    
}
static void
pcf_v_issss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, short, short, short, short);
    func_t pointer;
    call_state st;
    
    
    int t_1652;
    short t_1653;
    short t_1654;
    short t_1655;
    short t_1656;
    Parrot_init_arg_nci(interp, &st, "IIIII");
    t_1652 = (int)GET_NCI_I(0);
    t_1653 = (short)GET_NCI_I(1);
    t_1654 = (short)GET_NCI_I(2);
    t_1655 = (short)GET_NCI_I(3);
    t_1656 = (short)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1652,t_1653,t_1654,t_1655,t_1656);
    
    
    
}
static void
pcf_v_it(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char *);
    func_t pointer;
    call_state st;
    
    
    int t_1657;
    char *t_1658;
    Parrot_init_arg_nci(interp, &st, "IS");
    t_1657 = (int)GET_NCI_I(0);
    t_1658 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1657,t_1658);
    
    
    string_cstring_free(t_1658);
}
static void
pcf_v_iti(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, char *, int);
    func_t pointer;
    call_state st;
    
    
    int t_1659;
    char *t_1660;
    int t_1661;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_1659 = (int)GET_NCI_I(0);
    t_1660 = string_to_cstring(interp, GET_NCI_S(1));
    t_1661 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1659,t_1660,t_1661);
    
    
    string_cstring_free(t_1660);
}
static void
pcf_v_liii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(long, int, int, int);
    func_t pointer;
    call_state st;
    
    
    long t_1662;
    int t_1663;
    int t_1664;
    int t_1665;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1662 = (long)GET_NCI_I(0);
    t_1663 = (int)GET_NCI_I(1);
    t_1664 = (int)GET_NCI_I(2);
    t_1665 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1662,t_1663,t_1664,t_1665);
    
    
    
}
static void
pcf_v_pc(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1666;
    char t_1667;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_1666 = GET_NCI_P(0);
    t_1667 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1666),t_1667);
    
    
    
}
static void
pcf_v_pddd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, double, double, double);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1668;
    double t_1669;
    double t_1670;
    double t_1671;
    Parrot_init_arg_nci(interp, &st, "PNNN");
    t_1668 = GET_NCI_P(0);
    t_1669 = (double)GET_NCI_N(1);
    t_1670 = (double)GET_NCI_N(2);
    t_1671 = (double)GET_NCI_N(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1668),t_1669,t_1670,t_1671);
    
    
    
}
static void
pcf_v_pdddii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, double, double, double, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1672;
    double t_1673;
    double t_1674;
    double t_1675;
    int t_1676;
    int t_1677;
    Parrot_init_arg_nci(interp, &st, "PNNNII");
    t_1672 = GET_NCI_P(0);
    t_1673 = (double)GET_NCI_N(1);
    t_1674 = (double)GET_NCI_N(2);
    t_1675 = (double)GET_NCI_N(3);
    t_1676 = (int)GET_NCI_I(4);
    t_1677 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1672),t_1673,t_1674,t_1675,t_1676,t_1677);
    
    
    
}
static void
pcf_v_pddii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, double, double, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1678;
    double t_1679;
    double t_1680;
    int t_1681;
    int t_1682;
    Parrot_init_arg_nci(interp, &st, "PNNII");
    t_1678 = GET_NCI_P(0);
    t_1679 = (double)GET_NCI_N(1);
    t_1680 = (double)GET_NCI_N(2);
    t_1681 = (int)GET_NCI_I(3);
    t_1682 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1678),t_1679,t_1680,t_1681,t_1682);
    
    
    
}
static void
pcf_v_pddiidd(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, double, double, int, int, double, double);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1683;
    double t_1684;
    double t_1685;
    int t_1686;
    int t_1687;
    double t_1688;
    double t_1689;
    Parrot_init_arg_nci(interp, &st, "PNNIINN");
    t_1683 = GET_NCI_P(0);
    t_1684 = (double)GET_NCI_N(1);
    t_1685 = (double)GET_NCI_N(2);
    t_1686 = (int)GET_NCI_I(3);
    t_1687 = (int)GET_NCI_I(4);
    t_1688 = (double)GET_NCI_N(5);
    t_1689 = (double)GET_NCI_N(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1683),t_1684,t_1685,t_1686,t_1687,t_1688,t_1689);
    
    
    
}
static void
pcf_v_pdii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, double, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1690;
    double t_1691;
    int t_1692;
    int t_1693;
    Parrot_init_arg_nci(interp, &st, "PNII");
    t_1690 = GET_NCI_P(0);
    t_1691 = (double)GET_NCI_N(1);
    t_1692 = (int)GET_NCI_I(2);
    t_1693 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1690),t_1691,t_1692,t_1693);
    
    
    
}
static void
pcf_v_pid(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, double);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1694;
    int t_1695;
    double t_1696;
    Parrot_init_arg_nci(interp, &st, "PIN");
    t_1694 = GET_NCI_P(0);
    t_1695 = (int)GET_NCI_I(1);
    t_1696 = (double)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1694),t_1695,t_1696);
    
    
    
}
static void
pcf_v_pif(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, float);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1697;
    int t_1698;
    float t_1699;
    Parrot_init_arg_nci(interp, &st, "PIN");
    t_1697 = GET_NCI_P(0);
    t_1698 = (int)GET_NCI_I(1);
    t_1699 = (float)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1697),t_1698,t_1699);
    
    
    
}
static void
pcf_v_pipii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1700;
    int t_1701;
    PMC *t_1702;
    int t_1703;
    int t_1704;
    Parrot_init_arg_nci(interp, &st, "PIPII");
    t_1700 = GET_NCI_P(0);
    t_1701 = (int)GET_NCI_I(1);
    t_1702 = GET_NCI_P(2);
    t_1703 = (int)GET_NCI_I(3);
    t_1704 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1700),t_1701,PMC_data(t_1702),t_1703,t_1704);
    
    
    
}
static void
pcf_v_pipipii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *, int, void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1705;
    int t_1706;
    PMC *t_1707;
    int t_1708;
    PMC *t_1709;
    int t_1710;
    int t_1711;
    Parrot_init_arg_nci(interp, &st, "PIPIPII");
    t_1705 = GET_NCI_P(0);
    t_1706 = (int)GET_NCI_I(1);
    t_1707 = GET_NCI_P(2);
    t_1708 = (int)GET_NCI_I(3);
    t_1709 = GET_NCI_P(4);
    t_1710 = (int)GET_NCI_I(5);
    t_1711 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1705),t_1706,PMC_data(t_1707),t_1708,PMC_data(t_1709),t_1710,t_1711);
    
    
    
}
static void
pcf_v_pipipiipiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *, int, void *, int, int, void *, int, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1712;
    int t_1713;
    PMC *t_1714;
    int t_1715;
    PMC *t_1716;
    int t_1717;
    int t_1718;
    PMC *t_1719;
    int t_1720;
    int t_1721;
    int t_1722;
    Parrot_init_arg_nci(interp, &st, "PIPIPIIPIII");
    t_1712 = GET_NCI_P(0);
    t_1713 = (int)GET_NCI_I(1);
    t_1714 = GET_NCI_P(2);
    t_1715 = (int)GET_NCI_I(3);
    t_1716 = GET_NCI_P(4);
    t_1717 = (int)GET_NCI_I(5);
    t_1718 = (int)GET_NCI_I(6);
    t_1719 = GET_NCI_P(7);
    t_1720 = (int)GET_NCI_I(8);
    t_1721 = (int)GET_NCI_I(9);
    t_1722 = (int)GET_NCI_I(10);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1712),t_1713,PMC_data(t_1714),t_1715,PMC_data(t_1716),t_1717,t_1718,PMC_data(t_1719),t_1720,t_1721,t_1722);
    
    
    
}
static void
pcf_v_plf(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, float);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1723;
    long t_1724;
    float t_1725;
    Parrot_init_arg_nci(interp, &st, "PIN");
    t_1723 = GET_NCI_P(0);
    t_1724 = (long)GET_NCI_I(1);
    t_1725 = (float)GET_NCI_N(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1723),t_1724,t_1725);
    
    
    
}
static void
pcf_v_pli(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1726;
    long t_1727;
    int t_1728;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_1726 = GET_NCI_P(0);
    t_1727 = (long)GET_NCI_I(1);
    t_1728 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1726),t_1727,t_1728);
    
    
    
}
static void
pcf_v_pliiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1729;
    long t_1730;
    int t_1731;
    int t_1732;
    int t_1733;
    int t_1734;
    Parrot_init_arg_nci(interp, &st, "PIIIII");
    t_1729 = GET_NCI_P(0);
    t_1730 = (long)GET_NCI_I(1);
    t_1731 = (int)GET_NCI_I(2);
    t_1732 = (int)GET_NCI_I(3);
    t_1733 = (int)GET_NCI_I(4);
    t_1734 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1729),t_1730,t_1731,t_1732,t_1733,t_1734);
    
    
    
}
static void
pcf_v_plip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, int, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1735;
    long t_1736;
    int t_1737;
    PMC *t_1738;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_1735 = GET_NCI_P(0);
    t_1736 = (long)GET_NCI_I(1);
    t_1737 = (int)GET_NCI_I(2);
    t_1738 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1735),t_1736,t_1737,PMC_data(t_1738));
    
    
    
}
static void
pcf_v_pll(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, long);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1739;
    long t_1740;
    long t_1741;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_1739 = GET_NCI_P(0);
    t_1740 = (long)GET_NCI_I(1);
    t_1741 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1739),t_1740,t_1741);
    
    
    
}
static void
pcf_v_plp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1742;
    long t_1743;
    PMC *t_1744;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_1742 = GET_NCI_P(0);
    t_1743 = (long)GET_NCI_I(1);
    t_1744 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1742),t_1743,PMC_data(t_1744));
    
    
    
}
static void
pcf_v_ppipii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1745;
    PMC *t_1746;
    int t_1747;
    PMC *t_1748;
    int t_1749;
    int t_1750;
    Parrot_init_arg_nci(interp, &st, "PPIPII");
    t_1745 = GET_NCI_P(0);
    t_1746 = GET_NCI_P(1);
    t_1747 = (int)GET_NCI_I(2);
    t_1748 = GET_NCI_P(3);
    t_1749 = (int)GET_NCI_I(4);
    t_1750 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1745),PMC_data(t_1746),t_1747,PMC_data(t_1748),t_1749,t_1750);
    
    
    
}
static void
pcf_v_ppp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1751;
    PMC *t_1752;
    PMC *t_1753;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_1751 = GET_NCI_P(0);
    t_1752 = GET_NCI_P(1);
    t_1753 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1751),PMC_data(t_1752),PMC_data(t_1753));
    
    
    
}
static void
pcf_v_pppii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1754;
    PMC *t_1755;
    PMC *t_1756;
    int t_1757;
    int t_1758;
    Parrot_init_arg_nci(interp, &st, "PPPII");
    t_1754 = GET_NCI_P(0);
    t_1755 = GET_NCI_P(1);
    t_1756 = GET_NCI_P(2);
    t_1757 = (int)GET_NCI_I(3);
    t_1758 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1754),PMC_data(t_1755),PMC_data(t_1756),t_1757,t_1758);
    
    
    
}
static void
pcf_v_pppl(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, void *, long);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1759;
    PMC *t_1760;
    PMC *t_1761;
    long t_1762;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_1759 = GET_NCI_P(0);
    t_1760 = GET_NCI_P(1);
    t_1761 = GET_NCI_P(2);
    t_1762 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1759),PMC_data(t_1760),PMC_data(t_1761),t_1762);
    
    
    
}
static void
pcf_v_pppp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1763;
    PMC *t_1764;
    PMC *t_1765;
    PMC *t_1766;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_1763 = GET_NCI_P(0);
    t_1764 = GET_NCI_P(1);
    t_1765 = GET_NCI_P(2);
    t_1766 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1763),PMC_data(t_1764),PMC_data(t_1765),PMC_data(t_1766));
    
    
    
}
static void
pcf_v_ppppp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1767;
    PMC *t_1768;
    PMC *t_1769;
    PMC *t_1770;
    PMC *t_1771;
    Parrot_init_arg_nci(interp, &st, "PPPPP");
    t_1767 = GET_NCI_P(0);
    t_1768 = GET_NCI_P(1);
    t_1769 = GET_NCI_P(2);
    t_1770 = GET_NCI_P(3);
    t_1771 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1767),PMC_data(t_1768),PMC_data(t_1769),PMC_data(t_1770),PMC_data(t_1771));
    
    
    
}
static void
pcf_v_ptp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_1772;
    char *t_1773;
    PMC *t_1774;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_1772 = GET_NCI_P(0);
    t_1773 = string_to_cstring(interp, GET_NCI_S(1));
    t_1774 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_1772),t_1773,PMC_data(t_1774));
    
    
    string_cstring_free(t_1773);
}
static void
pcf_v_s(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(short);
    func_t pointer;
    call_state st;
    
    
    short t_1775;
    Parrot_init_arg_nci(interp, &st, "I");
    t_1775 = (short)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1775);
    
    
    
}
static void
pcf_v_ss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(short, short);
    func_t pointer;
    call_state st;
    
    
    short t_1776;
    short t_1777;
    Parrot_init_arg_nci(interp, &st, "II");
    t_1776 = (short)GET_NCI_I(0);
    t_1777 = (short)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1776,t_1777);
    
    
    
}
static void
pcf_v_sss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(short, short, short);
    func_t pointer;
    call_state st;
    
    
    short t_1778;
    short t_1779;
    short t_1780;
    Parrot_init_arg_nci(interp, &st, "III");
    t_1778 = (short)GET_NCI_I(0);
    t_1779 = (short)GET_NCI_I(1);
    t_1780 = (short)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1778,t_1779,t_1780);
    
    
    
}
static void
pcf_v_ssss(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(short, short, short, short);
    func_t pointer;
    call_state st;
    
    
    short t_1781;
    short t_1782;
    short t_1783;
    short t_1784;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_1781 = (short)GET_NCI_I(0);
    t_1782 = (short)GET_NCI_I(1);
    t_1783 = (short)GET_NCI_I(2);
    t_1784 = (short)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1781,t_1782,t_1783,t_1784);
    
    
    
}
static void
pcf_v_ti(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *, int);
    func_t pointer;
    call_state st;
    
    
    char *t_1785;
    int t_1786;
    Parrot_init_arg_nci(interp, &st, "SI");
    t_1785 = string_to_cstring(interp, GET_NCI_S(0));
    t_1786 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1785,t_1786);
    
    
    string_cstring_free(t_1785);
}
static void
pcf_v_tp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *, void *);
    func_t pointer;
    call_state st;
    
    
    char *t_1787;
    PMC *t_1788;
    Parrot_init_arg_nci(interp, &st, "SP");
    t_1787 = string_to_cstring(interp, GET_NCI_S(0));
    t_1788 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_1787,PMC_data(t_1788));
    
    
    string_cstring_free(t_1787);
}


/* This function serves a single purpose. It takes the function
   signature for a C function we want to call and returns a pointer
   to a function that can call it. */
void *
build_call_func(PARROT_INTERP, SHIM(PMC *pmc_nci), NOTNULL(STRING *signature))
{
    char       *c;
    STRING     *ns, *message;
    PMC        *b;
    PMC        *iglobals;
    PMC        *temp_pmc;
    UINTVAL    signature_len;

    PMC        *HashPointer   = NULL;

#if defined(CAN_BUILD_CALL_FRAMES)
    /* Try if JIT code can build that signature. If yes, we are done */
    void * const result = Parrot_jit_build_call_func(interp, pmc_nci, signature);
    if (result)
        return result;
#endif
    /* And in here is the platform-independent way. Which is to say
       "here there be hacks" */
    signature_len = string_length(interp, signature);
    if (0 == signature_len)
       return F2DPTR(pcf_v_);
    /* remove deprecated void argument 'v' character */
    if (2 == signature_len && 'v' == string_index(interp, signature, 1)) {
       Parrot_warn(interp, PARROT_WARNINGS_ALL_FLAG, "function signature argument character 'v' ignored");
       string_chopn_inplace(interp, signature, 1);
       signature_len = string_length(interp, signature);
    }

    iglobals = interp->iglobals;

    if (PMC_IS_NULL(iglobals))
        PANIC(interp, "iglobals isn't created yet");
    HashPointer = VTABLE_get_pmc_keyed_int(interp, iglobals,
            IGLOBALS_NCI_FUNCS);

    if (!HashPointer) {
        HashPointer = pmc_new(interp, enum_class_Hash);
        VTABLE_set_pmc_keyed_int(interp, iglobals, IGLOBALS_NCI_FUNCS,
                HashPointer);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_JOd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "dJOd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPN;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPN"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOSSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOIPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOIP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JpP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jpii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "itp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_Jpti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tJpti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jtiiipt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJtiiipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "v"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_illllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "villllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSII;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOSII"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_N_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "NJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JON;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJON"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOIS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOIS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i3i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii3i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_lttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "llttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "Si"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cpttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pttttiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppttttiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ptl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iptl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tiB3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptiB3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tip3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptip3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pPtiiipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipPtiiipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tpiibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "itpiibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptippppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptippppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi33ipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppi33ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pttip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppttip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptipppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ppP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pppP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipt33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "c"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "d"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "dd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "f"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_ff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "fff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_is;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "fis"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ib"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "id"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "il"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_li;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ilp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip333333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pli;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipli"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pllllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipllllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_psp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pitl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s22;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is22"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s222;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is222"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ssss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "issss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "it"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_l4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ll4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lp33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "l33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tpp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ttttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pttttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "s"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "t"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tl4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ttl4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tt4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ssc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "csc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i3;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii3"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ci"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_ipt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_tt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ctt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "fii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ddddpppddpppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iddddpppddpppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_dddpppppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "idddpppppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiiipiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiiipiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_it;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piipppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiipppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pllp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipllp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plpp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ppiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lppiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ppl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lppl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ppll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lppll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pplp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ifff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pifff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pilfff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppilfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ppipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pppipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_3p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "v3p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_c;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ccc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vccc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_cccc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vcccc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ccccff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vccccff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ccccfff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vccccfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_dd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vdd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_dddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vdddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_dddddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vdddddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ddddddddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vddddddddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ddddp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vddddp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ddii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vddii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_dii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vdii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_f;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vf"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_fc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vfc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffccccfff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffccccfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_fff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_fffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vfffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ffffffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vffffffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_fffffffffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vfffffffffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iccc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viccc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_icccc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vicccc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iccccfff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viccccfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iciip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viciip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_id;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vid"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_idd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vidd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_idddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vidddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iddidd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viddidd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iddiiddiiddiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viddiiddiiddiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iddiiddiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viddiiddiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iddiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viddiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_if;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vif"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ifff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vifff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ifffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vifffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffffffffffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffffffffffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffiff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffiff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffiiffiiffiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffiiffiiffiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffiiffiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffiiffiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iffiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viffiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iic;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viic"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iicp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viicp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iid;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viid"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iidddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viidddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iif;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viif"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iifffft;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viifffft"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiic;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiic"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiciii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiciii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiicip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiicip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiicp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiicp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiccc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiccc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiicp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiicp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiiipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiiipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiiipt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiiipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiill;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiill"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiippi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiippp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiippp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiipppt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiipppt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iiit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iipt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iitdddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viitdddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iitffff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viitffff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iitp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viitp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ill;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vill"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_illp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "villp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ilpi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vilpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ipipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vipipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ippi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ippii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vippii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_is;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vis"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_isss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "visss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_issss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vissss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_it;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_iti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "viti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_liii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vliii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pddd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpddd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pdddii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpdddii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pddii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpddii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pddiidd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpddiidd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pdii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpdii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pid;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpid"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pif;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpif"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pipii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pipipii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpipipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pipipiipiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpipipiipiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_plf;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vplf"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pli;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpli"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pliiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpliiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_plip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vplip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_plp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ppipii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vppipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pppii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pppl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpppl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ppppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vppppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ptp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vptp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_s;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vs"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_sss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vsss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ssss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vssss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_tp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vtp"), temp_pmc);


    }

    b = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);

    if (b && b->vtable->base_type == enum_class_UnManagedStruct)
        return F2DPTR(PMC_data(b));

    /*
      These three lines have been added to aid debugging. I want to be able to
      see which signature has an unknown type. I am sure someone can come up
      with a neater way to do this.
     */
    ns = string_make(interp, " is an unknown signature type", 29, "ascii", 0);
    message = string_concat(interp, signature, ns, 0);

#if defined(CAN_BUILD_CALL_FRAMES)
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is enabled, this should not happen", 58, "ascii", 0);
#else
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is disabled, add the signature to src/call_list.txt", 75, "ascii", 0);
#endif
    message = string_concat(interp, message, ns, 0);

    /*
     * I think there may be memory issues with this but if we get to here we are
     * aborting.
     */
    c = string_to_cstring(interp, message);
    PANIC(interp, c);
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
